/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 ******************************************************************************/
package org.polarsys.esf.fmea.metamodel;

import org.eclipse.emf.common.EMFPlugin;
import org.eclipse.emf.common.util.ResourceLocator;

/**
 * The activator class controls the plug-in life cycle. Central singleton for
 * the ESFFMEA Meta-model plug-in.
 *
 * @author $Author: ogurcan $
 * @version $Revision: 169 $
 */
public class ESFFMEAMetamodelActivator
extends EMFPlugin {

/** Keep track of the encapsulating singleton. */
public static final ESFFMEAMetamodelActivator INSTANCE = new ESFFMEAMetamodelActivator();

/** Keep track of the implementation singleton. */
private static Implementation sPlugin = null;

/**
 * Create the instance.
 */
public ESFFMEAMetamodelActivator() {
    super(new ResourceLocator[] {});
}

/**
 * {@inheritDoc}
 */
@Override
public ResourceLocator getPluginResourceLocator() {
    return sPlugin;
}

/**
 * Returns the singleton instance of the Eclipse plugin.
 *
 * @return The singleton instance
 */
public static Implementation getPlugin() {
    return sPlugin;
}

/**
 * The actual implementation of the Eclipse <b>UIPlugin</b>.
 */
public static class Implementation
    extends EclipsePlugin {

    /**
     * Creates an instance.
     */
    public Implementation() {
        super();

        // Remember of the static instance
        sPlugin = this;
    }
}
}
