/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.polarsys.esf.esfcore.IESFCorePackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.polarsys.esf.esffmea.IESFFMEAFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/uml2/2.0.0/UML originalName='ESFFMEA'"
 * @generated
 */
public interface IESFFMEAPackage extends EPackage {
    /**
     * The package name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNAME = "esffmea";

    /**
     * The package namespace URI.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_URI = "http://www.polarsys.org/esf/0.7.0/ESFFMEA";

    /**
     * The package namespace name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_PREFIX = "ESFFMEA";

    /**
     * The singleton instance of the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    IESFFMEAPackage eINSTANCE = org.polarsys.esf.esffmea.impl.ESFFMEAPackage.init();

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.SFMEA <em>SFMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.SFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSFMEA()
     * @generated
     */
    int SFMEA = 0;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFMEA__UUID = IESFCorePackage.ABSTRACT_SSAFETY_ANALYSIS__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFMEA__NAME = IESFCorePackage.ABSTRACT_SSAFETY_ANALYSIS__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFMEA__DESCRIPTION = IESFCorePackage.ABSTRACT_SSAFETY_ANALYSIS__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SSafety Concepts List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFMEA__SSAFETY_CONCEPTS_LIST = IESFCorePackage.ABSTRACT_SSAFETY_ANALYSIS__SSAFETY_CONCEPTS_LIST;

    /**
     * The feature id for the '<em><b>Base Package</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFMEA__BASE_PACKAGE = IESFCorePackage.ABSTRACT_SSAFETY_ANALYSIS_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>SFMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFMEA_FEATURE_COUNT = IESFCorePackage.ABSTRACT_SSAFETY_ANALYSIS_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>SFMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFMEA_OPERATION_COUNT = IESFCorePackage.ABSTRACT_SSAFETY_ANALYSIS_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.AbstractSFMEAElement <em>Abstract SFMEA Element</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.AbstractSFMEAElement
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getAbstractSFMEAElement()
     * @generated
     */
    int ABSTRACT_SFMEA_ELEMENT = 1;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SFMEA_ELEMENT__UUID = IESFCorePackage.ABSTRACT_SSAFETY_CONCEPT__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SFMEA_ELEMENT__NAME = IESFCorePackage.ABSTRACT_SSAFETY_CONCEPT__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SFMEA_ELEMENT__DESCRIPTION = IESFCorePackage.ABSTRACT_SSAFETY_CONCEPT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SFMEA_ELEMENT__SARCHITECTURE_ELEMENTS_LIST = IESFCorePackage.ABSTRACT_SSAFETY_CONCEPT__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The number of structural features of the '<em>Abstract SFMEA Element</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT = IESFCorePackage.ABSTRACT_SSAFETY_CONCEPT_FEATURE_COUNT + 0;

    /**
     * The number of operations of the '<em>Abstract SFMEA Element</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SFMEA_ELEMENT_OPERATION_COUNT = IESFCorePackage.ABSTRACT_SSAFETY_CONCEPT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.SBlockFMEA <em>SBlock FMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.SBlockFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSBlockFMEA()
     * @generated
     */
    int SBLOCK_FMEA = 2;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__UUID = ABSTRACT_SFMEA_ELEMENT__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__NAME = ABSTRACT_SFMEA_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__DESCRIPTION = ABSTRACT_SFMEA_ELEMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__SARCHITECTURE_ELEMENTS_LIST = ABSTRACT_SFMEA_ELEMENT__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The feature id for the '<em><b>SBlock</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__SBLOCK = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Criticality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__CRITICALITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Diagnostic Coverage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__DIAGNOSTIC_COVERAGE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Ssf</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__SSF = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>SFailure Mode FMEA</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__SFAILURE_MODE_FMEA = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Base Class</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA__BASE_CLASS = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 5;

    /**
     * The number of structural features of the '<em>SBlock FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA_FEATURE_COUNT = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 6;

    /**
     * The number of operations of the '<em>SBlock FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SBLOCK_FMEA_OPERATION_COUNT = ABSTRACT_SFMEA_ELEMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA <em>SFailure Mode FMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.SFailureModeFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSFailureModeFMEA()
     * @generated
     */
    int SFAILURE_MODE_FMEA = 3;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__UUID = ABSTRACT_SFMEA_ELEMENT__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__NAME = ABSTRACT_SFMEA_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__DESCRIPTION = ABSTRACT_SFMEA_ELEMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SARCHITECTURE_ELEMENTS_LIST = ABSTRACT_SFMEA_ELEMENT__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The feature id for the '<em><b>SFailure Mode</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SFAILURE_MODE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Remarks</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__REMARKS = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SEVERITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Initial Criticality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__INITIAL_CRITICALITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Final Criticality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__FINAL_CRITICALITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Is Safe</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__IS_SAFE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Diagnostics</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__DIAGNOSTICS = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 6;

    /**
     * The feature id for the '<em><b>Failure Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__FAILURE_RATE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 7;

    /**
     * The feature id for the '<em><b>Initial Cause Occurence</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__INITIAL_CAUSE_OCCURENCE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 8;

    /**
     * The feature id for the '<em><b>Final Cause Occurence</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__FINAL_CAUSE_OCCURENCE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 9;

    /**
     * The feature id for the '<em><b>Local Effect Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__LOCAL_EFFECT_SEVERITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 10;

    /**
     * The feature id for the '<em><b>System Effect Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SYSTEM_EFFECT_SEVERITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 11;

    /**
     * The feature id for the '<em><b>Customer Effect Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__CUSTOMER_EFFECT_SEVERITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 12;

    /**
     * The feature id for the '<em><b>Diagnostic coverage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__DIAGNOSTIC_COVERAGE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 13;

    /**
     * The feature id for the '<em><b>Ssf</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SSF = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 14;

    /**
     * The feature id for the '<em><b>Is Detectable</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__IS_DETECTABLE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 15;

    /**
     * The feature id for the '<em><b>Detectability</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__DETECTABILITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 16;

    /**
     * The feature id for the '<em><b>SPreventive Action FMEA</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SPREVENTIVE_ACTION_FMEA = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 17;

    /**
     * The feature id for the '<em><b>SCause FMEA</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SCAUSE_FMEA = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 18;

    /**
     * The feature id for the '<em><b>SSystem Effect FMEA</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SSYSTEM_EFFECT_FMEA = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 19;

    /**
     * The feature id for the '<em><b>SCustomer Effect FMEA</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SCUSTOMER_EFFECT_FMEA = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 20;

    /**
     * The feature id for the '<em><b>SLocal Effect FMEA</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__SLOCAL_EFFECT_FMEA = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 21;

    /**
     * The feature id for the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA__BASE_PROPERTY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 22;

    /**
     * The number of structural features of the '<em>SFailure Mode FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA_FEATURE_COUNT = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 23;

    /**
     * The number of operations of the '<em>SFailure Mode FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SFAILURE_MODE_FMEA_OPERATION_COUNT = ABSTRACT_SFMEA_ELEMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.SPreventiveActionFMEA <em>SPreventive Action FMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.SPreventiveActionFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSPreventiveActionFMEA()
     * @generated
     */
    int SPREVENTIVE_ACTION_FMEA = 4;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA__UUID = ABSTRACT_SFMEA_ELEMENT__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA__NAME = ABSTRACT_SFMEA_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA__DESCRIPTION = ABSTRACT_SFMEA_ELEMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA__SARCHITECTURE_ELEMENTS_LIST = ABSTRACT_SFMEA_ELEMENT__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The feature id for the '<em><b>SAction</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA__SACTION = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA__ID = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA__BASE_PROPERTY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>SPreventive Action FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA_FEATURE_COUNT = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>SPreventive Action FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SPREVENTIVE_ACTION_FMEA_OPERATION_COUNT = ABSTRACT_SFMEA_ELEMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.SCauseFMEA <em>SCause FMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.SCauseFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSCauseFMEA()
     * @generated
     */
    int SCAUSE_FMEA = 5;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__UUID = ABSTRACT_SFMEA_ELEMENT__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__NAME = ABSTRACT_SFMEA_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__DESCRIPTION = ABSTRACT_SFMEA_ELEMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__SARCHITECTURE_ELEMENTS_LIST = ABSTRACT_SFMEA_ELEMENT__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The feature id for the '<em><b>SCause</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__SCAUSE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__ID = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Initial Occurence</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__INITIAL_OCCURENCE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Final Occurence</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__FINAL_OCCURENCE = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA__BASE_PROPERTY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>SCause FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA_FEATURE_COUNT = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 5;

    /**
     * The number of operations of the '<em>SCause FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCAUSE_FMEA_OPERATION_COUNT = ABSTRACT_SFMEA_ELEMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.AbstractSEventEffectFMEA <em>Abstract SEvent Effect FMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.AbstractSEventEffectFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getAbstractSEventEffectFMEA()
     * @generated
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA = 7;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA__UUID = ABSTRACT_SFMEA_ELEMENT__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA__NAME = ABSTRACT_SFMEA_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA__DESCRIPTION = ABSTRACT_SFMEA_ELEMENT__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA__SARCHITECTURE_ELEMENTS_LIST = ABSTRACT_SFMEA_ELEMENT__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The feature id for the '<em><b>SEffect</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA__SEFFECT = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA__ID = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA__SEVERITY = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>Abstract SEvent Effect FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA_FEATURE_COUNT = ABSTRACT_SFMEA_ELEMENT_FEATURE_COUNT + 3;

    /**
     * The number of operations of the '<em>Abstract SEvent Effect FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ABSTRACT_SEVENT_EFFECT_FMEA_OPERATION_COUNT = ABSTRACT_SFMEA_ELEMENT_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.SSytemEffectFMEA <em>SSytem Effect FMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.SSytemEffectFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSSytemEffectFMEA()
     * @generated
     */
    int SSYTEM_EFFECT_FMEA = 6;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA__UUID = ABSTRACT_SEVENT_EFFECT_FMEA__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA__NAME = ABSTRACT_SEVENT_EFFECT_FMEA__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA__DESCRIPTION = ABSTRACT_SEVENT_EFFECT_FMEA__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA__SARCHITECTURE_ELEMENTS_LIST = ABSTRACT_SEVENT_EFFECT_FMEA__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The feature id for the '<em><b>SEffect</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA__SEFFECT = ABSTRACT_SEVENT_EFFECT_FMEA__SEFFECT;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA__ID = ABSTRACT_SEVENT_EFFECT_FMEA__ID;

    /**
     * The feature id for the '<em><b>Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA__SEVERITY = ABSTRACT_SEVENT_EFFECT_FMEA__SEVERITY;

    /**
     * The feature id for the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA__BASE_PROPERTY = ABSTRACT_SEVENT_EFFECT_FMEA_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>SSytem Effect FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA_FEATURE_COUNT = ABSTRACT_SEVENT_EFFECT_FMEA_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>SSytem Effect FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SSYTEM_EFFECT_FMEA_OPERATION_COUNT = ABSTRACT_SEVENT_EFFECT_FMEA_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.SCustomerEffectFMEA <em>SCustomer Effect FMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.SCustomerEffectFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSCustomerEffectFMEA()
     * @generated
     */
    int SCUSTOMER_EFFECT_FMEA = 8;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA__UUID = ABSTRACT_SEVENT_EFFECT_FMEA__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA__NAME = ABSTRACT_SEVENT_EFFECT_FMEA__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA__DESCRIPTION = ABSTRACT_SEVENT_EFFECT_FMEA__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA__SARCHITECTURE_ELEMENTS_LIST = ABSTRACT_SEVENT_EFFECT_FMEA__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The feature id for the '<em><b>SEffect</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA__SEFFECT = ABSTRACT_SEVENT_EFFECT_FMEA__SEFFECT;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA__ID = ABSTRACT_SEVENT_EFFECT_FMEA__ID;

    /**
     * The feature id for the '<em><b>Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA__SEVERITY = ABSTRACT_SEVENT_EFFECT_FMEA__SEVERITY;

    /**
     * The feature id for the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA__BASE_PROPERTY = ABSTRACT_SEVENT_EFFECT_FMEA_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>SCustomer Effect FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA_FEATURE_COUNT = ABSTRACT_SEVENT_EFFECT_FMEA_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>SCustomer Effect FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCUSTOMER_EFFECT_FMEA_OPERATION_COUNT = ABSTRACT_SEVENT_EFFECT_FMEA_OPERATION_COUNT + 0;

    /**
     * The meta object id for the '{@link org.polarsys.esf.esffmea.impl.SLocalEffectFMEA <em>SLocal Effect FMEA</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.polarsys.esf.esffmea.impl.SLocalEffectFMEA
     * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSLocalEffectFMEA()
     * @generated
     */
    int SLOCAL_EFFECT_FMEA = 9;

    /**
     * The feature id for the '<em><b>UUID</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA__UUID = ABSTRACT_SEVENT_EFFECT_FMEA__UUID;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA__NAME = ABSTRACT_SEVENT_EFFECT_FMEA__NAME;

    /**
     * The feature id for the '<em><b>Description</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA__DESCRIPTION = ABSTRACT_SEVENT_EFFECT_FMEA__DESCRIPTION;

    /**
     * The feature id for the '<em><b>SArchitecture Elements List</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA__SARCHITECTURE_ELEMENTS_LIST = ABSTRACT_SEVENT_EFFECT_FMEA__SARCHITECTURE_ELEMENTS_LIST;

    /**
     * The feature id for the '<em><b>SEffect</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA__SEFFECT = ABSTRACT_SEVENT_EFFECT_FMEA__SEFFECT;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA__ID = ABSTRACT_SEVENT_EFFECT_FMEA__ID;

    /**
     * The feature id for the '<em><b>Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA__SEVERITY = ABSTRACT_SEVENT_EFFECT_FMEA__SEVERITY;

    /**
     * The feature id for the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA__BASE_PROPERTY = ABSTRACT_SEVENT_EFFECT_FMEA_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>SLocal Effect FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA_FEATURE_COUNT = ABSTRACT_SEVENT_EFFECT_FMEA_FEATURE_COUNT + 1;

    /**
     * The number of operations of the '<em>SLocal Effect FMEA</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SLOCAL_EFFECT_FMEA_OPERATION_COUNT = ABSTRACT_SEVENT_EFFECT_FMEA_OPERATION_COUNT + 0;


    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.ISFMEA <em>SFMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SFMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISFMEA
     * @generated
     */
    EClass getSFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFMEA#getBase_Package <em>Base Package</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Package</em>'.
     * @see org.polarsys.esf.esffmea.ISFMEA#getBase_Package()
     * @see #getSFMEA()
     * @generated
     */
    EReference getSFMEA_Base_Package();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.IAbstractSFMEAElement <em>Abstract SFMEA Element</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Abstract SFMEA Element</em>'.
     * @see org.polarsys.esf.esffmea.IAbstractSFMEAElement
     * @generated
     */
    EClass getAbstractSFMEAElement();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.ISBlockFMEA <em>SBlock FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SBlock FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISBlockFMEA
     * @generated
     */
    EClass getSBlockFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getSBlock <em>SBlock</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>SBlock</em>'.
     * @see org.polarsys.esf.esffmea.ISBlockFMEA#getSBlock()
     * @see #getSBlockFMEA()
     * @generated
     */
    EReference getSBlockFMEA_SBlock();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getCriticality <em>Criticality</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Criticality</em>'.
     * @see org.polarsys.esf.esffmea.ISBlockFMEA#getCriticality()
     * @see #getSBlockFMEA()
     * @generated
     */
    EReference getSBlockFMEA_Criticality();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getDiagnosticCoverage <em>Diagnostic Coverage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Diagnostic Coverage</em>'.
     * @see org.polarsys.esf.esffmea.ISBlockFMEA#getDiagnosticCoverage()
     * @see #getSBlockFMEA()
     * @generated
     */
    EAttribute getSBlockFMEA_DiagnosticCoverage();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getSsf <em>Ssf</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ssf</em>'.
     * @see org.polarsys.esf.esffmea.ISBlockFMEA#getSsf()
     * @see #getSBlockFMEA()
     * @generated
     */
    EAttribute getSBlockFMEA_Ssf();

    /**
     * Returns the meta object for the reference list '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getSFailureModeFMEA <em>SFailure Mode FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>SFailure Mode FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISBlockFMEA#getSFailureModeFMEA()
     * @see #getSBlockFMEA()
     * @generated
     */
    EReference getSBlockFMEA_SFailureModeFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getBase_Class <em>Base Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Class</em>'.
     * @see org.polarsys.esf.esffmea.ISBlockFMEA#getBase_Class()
     * @see #getSBlockFMEA()
     * @generated
     */
    EReference getSBlockFMEA_Base_Class();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA <em>SFailure Mode FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SFailure Mode FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA
     * @generated
     */
    EClass getSFailureModeFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSFailureMode <em>SFailure Mode</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>SFailure Mode</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSFailureMode()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_SFailureMode();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getRemarks <em>Remarks</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Remarks</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getRemarks()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EAttribute getSFailureModeFMEA_Remarks();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSeverity <em>Severity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Severity</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSeverity()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_Severity();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getInitialCriticality <em>Initial Criticality</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Initial Criticality</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getInitialCriticality()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_InitialCriticality();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFinalCriticality <em>Final Criticality</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Final Criticality</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getFinalCriticality()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_FinalCriticality();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#isSafe <em>Is Safe</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Safe</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#isSafe()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EAttribute getSFailureModeFMEA_IsSafe();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDiagnostics <em>Diagnostics</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Diagnostics</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getDiagnostics()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EAttribute getSFailureModeFMEA_Diagnostics();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFailureRate <em>Failure Rate</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Failure Rate</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getFailureRate()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EAttribute getSFailureModeFMEA_FailureRate();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getInitialCauseOccurence <em>Initial Cause Occurence</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Initial Cause Occurence</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getInitialCauseOccurence()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_InitialCauseOccurence();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFinalCauseOccurence <em>Final Cause Occurence</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Final Cause Occurence</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getFinalCauseOccurence()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_FinalCauseOccurence();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getLocalEffectSeverity <em>Local Effect Severity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Local Effect Severity</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getLocalEffectSeverity()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_LocalEffectSeverity();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSystemEffectSeverity <em>System Effect Severity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>System Effect Severity</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSystemEffectSeverity()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_SystemEffectSeverity();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getCustomerEffectSeverity <em>Customer Effect Severity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Customer Effect Severity</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getCustomerEffectSeverity()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_CustomerEffectSeverity();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDiagnostic_coverage <em>Diagnostic coverage</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Diagnostic coverage</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getDiagnostic_coverage()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EAttribute getSFailureModeFMEA_Diagnostic_coverage();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSsf <em>Ssf</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Ssf</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSsf()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EAttribute getSFailureModeFMEA_Ssf();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#isDetectable <em>Is Detectable</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Is Detectable</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#isDetectable()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EAttribute getSFailureModeFMEA_IsDetectable();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDetectability <em>Detectability</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Detectability</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getDetectability()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_Detectability();

    /**
     * Returns the meta object for the reference list '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSPreventiveActionFMEA <em>SPreventive Action FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>SPreventive Action FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSPreventiveActionFMEA()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_SPreventiveActionFMEA();

    /**
     * Returns the meta object for the reference list '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSCauseFMEA <em>SCause FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>SCause FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSCauseFMEA()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_SCauseFMEA();

    /**
     * Returns the meta object for the reference list '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSSystemEffectFMEA <em>SSystem Effect FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>SSystem Effect FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSSystemEffectFMEA()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_SSystemEffectFMEA();

    /**
     * Returns the meta object for the reference list '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSCustomerEffectFMEA <em>SCustomer Effect FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>SCustomer Effect FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSCustomerEffectFMEA()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_SCustomerEffectFMEA();

    /**
     * Returns the meta object for the reference list '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSLocalEffectFMEA <em>SLocal Effect FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>SLocal Effect FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getSLocalEffectFMEA()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_SLocalEffectFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getBase_Property <em>Base Property</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Property</em>'.
     * @see org.polarsys.esf.esffmea.ISFailureModeFMEA#getBase_Property()
     * @see #getSFailureModeFMEA()
     * @generated
     */
    EReference getSFailureModeFMEA_Base_Property();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.ISPreventiveActionFMEA <em>SPreventive Action FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SPreventive Action FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISPreventiveActionFMEA
     * @generated
     */
    EClass getSPreventiveActionFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISPreventiveActionFMEA#getSAction <em>SAction</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>SAction</em>'.
     * @see org.polarsys.esf.esffmea.ISPreventiveActionFMEA#getSAction()
     * @see #getSPreventiveActionFMEA()
     * @generated
     */
    EReference getSPreventiveActionFMEA_SAction();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISPreventiveActionFMEA#getId <em>Id</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Id</em>'.
     * @see org.polarsys.esf.esffmea.ISPreventiveActionFMEA#getId()
     * @see #getSPreventiveActionFMEA()
     * @generated
     */
    EAttribute getSPreventiveActionFMEA_Id();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISPreventiveActionFMEA#getBase_Property <em>Base Property</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Property</em>'.
     * @see org.polarsys.esf.esffmea.ISPreventiveActionFMEA#getBase_Property()
     * @see #getSPreventiveActionFMEA()
     * @generated
     */
    EReference getSPreventiveActionFMEA_Base_Property();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.ISCauseFMEA <em>SCause FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SCause FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISCauseFMEA
     * @generated
     */
    EClass getSCauseFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getSCause <em>SCause</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>SCause</em>'.
     * @see org.polarsys.esf.esffmea.ISCauseFMEA#getSCause()
     * @see #getSCauseFMEA()
     * @generated
     */
    EReference getSCauseFMEA_SCause();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getId <em>Id</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Id</em>'.
     * @see org.polarsys.esf.esffmea.ISCauseFMEA#getId()
     * @see #getSCauseFMEA()
     * @generated
     */
    EAttribute getSCauseFMEA_Id();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getInitialOccurence <em>Initial Occurence</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Initial Occurence</em>'.
     * @see org.polarsys.esf.esffmea.ISCauseFMEA#getInitialOccurence()
     * @see #getSCauseFMEA()
     * @generated
     */
    EReference getSCauseFMEA_InitialOccurence();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getFinalOccurence <em>Final Occurence</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Final Occurence</em>'.
     * @see org.polarsys.esf.esffmea.ISCauseFMEA#getFinalOccurence()
     * @see #getSCauseFMEA()
     * @generated
     */
    EReference getSCauseFMEA_FinalOccurence();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getBase_Property <em>Base Property</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Property</em>'.
     * @see org.polarsys.esf.esffmea.ISCauseFMEA#getBase_Property()
     * @see #getSCauseFMEA()
     * @generated
     */
    EReference getSCauseFMEA_Base_Property();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.ISSytemEffectFMEA <em>SSytem Effect FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SSytem Effect FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISSytemEffectFMEA
     * @generated
     */
    EClass getSSytemEffectFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISSytemEffectFMEA#getBase_Property <em>Base Property</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Property</em>'.
     * @see org.polarsys.esf.esffmea.ISSytemEffectFMEA#getBase_Property()
     * @see #getSSytemEffectFMEA()
     * @generated
     */
    EReference getSSytemEffectFMEA_Base_Property();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.IAbstractSEventEffectFMEA <em>Abstract SEvent Effect FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Abstract SEvent Effect FMEA</em>'.
     * @see org.polarsys.esf.esffmea.IAbstractSEventEffectFMEA
     * @generated
     */
    EClass getAbstractSEventEffectFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.IAbstractSEventEffectFMEA#getSEffect <em>SEffect</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>SEffect</em>'.
     * @see org.polarsys.esf.esffmea.IAbstractSEventEffectFMEA#getSEffect()
     * @see #getAbstractSEventEffectFMEA()
     * @generated
     */
    EReference getAbstractSEventEffectFMEA_SEffect();

    /**
     * Returns the meta object for the attribute '{@link org.polarsys.esf.esffmea.IAbstractSEventEffectFMEA#getId <em>Id</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Id</em>'.
     * @see org.polarsys.esf.esffmea.IAbstractSEventEffectFMEA#getId()
     * @see #getAbstractSEventEffectFMEA()
     * @generated
     */
    EAttribute getAbstractSEventEffectFMEA_Id();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.IAbstractSEventEffectFMEA#getSeverity <em>Severity</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Severity</em>'.
     * @see org.polarsys.esf.esffmea.IAbstractSEventEffectFMEA#getSeverity()
     * @see #getAbstractSEventEffectFMEA()
     * @generated
     */
    EReference getAbstractSEventEffectFMEA_Severity();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.ISCustomerEffectFMEA <em>SCustomer Effect FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SCustomer Effect FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISCustomerEffectFMEA
     * @generated
     */
    EClass getSCustomerEffectFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISCustomerEffectFMEA#getBase_Property <em>Base Property</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Property</em>'.
     * @see org.polarsys.esf.esffmea.ISCustomerEffectFMEA#getBase_Property()
     * @see #getSCustomerEffectFMEA()
     * @generated
     */
    EReference getSCustomerEffectFMEA_Base_Property();

    /**
     * Returns the meta object for class '{@link org.polarsys.esf.esffmea.ISLocalEffectFMEA <em>SLocal Effect FMEA</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SLocal Effect FMEA</em>'.
     * @see org.polarsys.esf.esffmea.ISLocalEffectFMEA
     * @generated
     */
    EClass getSLocalEffectFMEA();

    /**
     * Returns the meta object for the reference '{@link org.polarsys.esf.esffmea.ISLocalEffectFMEA#getBase_Property <em>Base Property</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Base Property</em>'.
     * @see org.polarsys.esf.esffmea.ISLocalEffectFMEA#getBase_Property()
     * @see #getSLocalEffectFMEA()
     * @generated
     */
    EReference getSLocalEffectFMEA_Base_Property();

    /**
     * Returns the factory that creates the instances of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the factory that creates the instances of the model.
     * @generated
     */
    IESFFMEAFactory getESFFMEAFactory();

    /**
     * <!-- begin-user-doc -->
     * Defines literals for the meta objects that represent
     * <ul>
     *   <li>each class,</li>
     *   <li>each feature of each class,</li>
     *   <li>each operation of each class,</li>
     *   <li>each enum,</li>
     *   <li>and each data type</li>
     * </ul>
     * <!-- end-user-doc -->
     * @generated
     */
    interface Literals {
        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.SFMEA <em>SFMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.SFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSFMEA()
         * @generated
         */
        EClass SFMEA = eINSTANCE.getSFMEA();

        /**
         * The meta object literal for the '<em><b>Base Package</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFMEA__BASE_PACKAGE = eINSTANCE.getSFMEA_Base_Package();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.AbstractSFMEAElement <em>Abstract SFMEA Element</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.AbstractSFMEAElement
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getAbstractSFMEAElement()
         * @generated
         */
        EClass ABSTRACT_SFMEA_ELEMENT = eINSTANCE.getAbstractSFMEAElement();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.SBlockFMEA <em>SBlock FMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.SBlockFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSBlockFMEA()
         * @generated
         */
        EClass SBLOCK_FMEA = eINSTANCE.getSBlockFMEA();

        /**
         * The meta object literal for the '<em><b>SBlock</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SBLOCK_FMEA__SBLOCK = eINSTANCE.getSBlockFMEA_SBlock();

        /**
         * The meta object literal for the '<em><b>Criticality</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SBLOCK_FMEA__CRITICALITY = eINSTANCE.getSBlockFMEA_Criticality();

        /**
         * The meta object literal for the '<em><b>Diagnostic Coverage</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SBLOCK_FMEA__DIAGNOSTIC_COVERAGE = eINSTANCE.getSBlockFMEA_DiagnosticCoverage();

        /**
         * The meta object literal for the '<em><b>Ssf</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SBLOCK_FMEA__SSF = eINSTANCE.getSBlockFMEA_Ssf();

        /**
         * The meta object literal for the '<em><b>SFailure Mode FMEA</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SBLOCK_FMEA__SFAILURE_MODE_FMEA = eINSTANCE.getSBlockFMEA_SFailureModeFMEA();

        /**
         * The meta object literal for the '<em><b>Base Class</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SBLOCK_FMEA__BASE_CLASS = eINSTANCE.getSBlockFMEA_Base_Class();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA <em>SFailure Mode FMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.SFailureModeFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSFailureModeFMEA()
         * @generated
         */
        EClass SFAILURE_MODE_FMEA = eINSTANCE.getSFailureModeFMEA();

        /**
         * The meta object literal for the '<em><b>SFailure Mode</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__SFAILURE_MODE = eINSTANCE.getSFailureModeFMEA_SFailureMode();

        /**
         * The meta object literal for the '<em><b>Remarks</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SFAILURE_MODE_FMEA__REMARKS = eINSTANCE.getSFailureModeFMEA_Remarks();

        /**
         * The meta object literal for the '<em><b>Severity</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__SEVERITY = eINSTANCE.getSFailureModeFMEA_Severity();

        /**
         * The meta object literal for the '<em><b>Initial Criticality</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__INITIAL_CRITICALITY = eINSTANCE.getSFailureModeFMEA_InitialCriticality();

        /**
         * The meta object literal for the '<em><b>Final Criticality</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__FINAL_CRITICALITY = eINSTANCE.getSFailureModeFMEA_FinalCriticality();

        /**
         * The meta object literal for the '<em><b>Is Safe</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SFAILURE_MODE_FMEA__IS_SAFE = eINSTANCE.getSFailureModeFMEA_IsSafe();

        /**
         * The meta object literal for the '<em><b>Diagnostics</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SFAILURE_MODE_FMEA__DIAGNOSTICS = eINSTANCE.getSFailureModeFMEA_Diagnostics();

        /**
         * The meta object literal for the '<em><b>Failure Rate</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SFAILURE_MODE_FMEA__FAILURE_RATE = eINSTANCE.getSFailureModeFMEA_FailureRate();

        /**
         * The meta object literal for the '<em><b>Initial Cause Occurence</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__INITIAL_CAUSE_OCCURENCE = eINSTANCE.getSFailureModeFMEA_InitialCauseOccurence();

        /**
         * The meta object literal for the '<em><b>Final Cause Occurence</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__FINAL_CAUSE_OCCURENCE = eINSTANCE.getSFailureModeFMEA_FinalCauseOccurence();

        /**
         * The meta object literal for the '<em><b>Local Effect Severity</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__LOCAL_EFFECT_SEVERITY = eINSTANCE.getSFailureModeFMEA_LocalEffectSeverity();

        /**
         * The meta object literal for the '<em><b>System Effect Severity</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__SYSTEM_EFFECT_SEVERITY = eINSTANCE.getSFailureModeFMEA_SystemEffectSeverity();

        /**
         * The meta object literal for the '<em><b>Customer Effect Severity</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__CUSTOMER_EFFECT_SEVERITY = eINSTANCE.getSFailureModeFMEA_CustomerEffectSeverity();

        /**
         * The meta object literal for the '<em><b>Diagnostic coverage</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SFAILURE_MODE_FMEA__DIAGNOSTIC_COVERAGE = eINSTANCE.getSFailureModeFMEA_Diagnostic_coverage();

        /**
         * The meta object literal for the '<em><b>Ssf</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SFAILURE_MODE_FMEA__SSF = eINSTANCE.getSFailureModeFMEA_Ssf();

        /**
         * The meta object literal for the '<em><b>Is Detectable</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SFAILURE_MODE_FMEA__IS_DETECTABLE = eINSTANCE.getSFailureModeFMEA_IsDetectable();

        /**
         * The meta object literal for the '<em><b>Detectability</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__DETECTABILITY = eINSTANCE.getSFailureModeFMEA_Detectability();

        /**
         * The meta object literal for the '<em><b>SPreventive Action FMEA</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__SPREVENTIVE_ACTION_FMEA = eINSTANCE.getSFailureModeFMEA_SPreventiveActionFMEA();

        /**
         * The meta object literal for the '<em><b>SCause FMEA</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__SCAUSE_FMEA = eINSTANCE.getSFailureModeFMEA_SCauseFMEA();

        /**
         * The meta object literal for the '<em><b>SSystem Effect FMEA</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__SSYSTEM_EFFECT_FMEA = eINSTANCE.getSFailureModeFMEA_SSystemEffectFMEA();

        /**
         * The meta object literal for the '<em><b>SCustomer Effect FMEA</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__SCUSTOMER_EFFECT_FMEA = eINSTANCE.getSFailureModeFMEA_SCustomerEffectFMEA();

        /**
         * The meta object literal for the '<em><b>SLocal Effect FMEA</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__SLOCAL_EFFECT_FMEA = eINSTANCE.getSFailureModeFMEA_SLocalEffectFMEA();

        /**
         * The meta object literal for the '<em><b>Base Property</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SFAILURE_MODE_FMEA__BASE_PROPERTY = eINSTANCE.getSFailureModeFMEA_Base_Property();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.SPreventiveActionFMEA <em>SPreventive Action FMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.SPreventiveActionFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSPreventiveActionFMEA()
         * @generated
         */
        EClass SPREVENTIVE_ACTION_FMEA = eINSTANCE.getSPreventiveActionFMEA();

        /**
         * The meta object literal for the '<em><b>SAction</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SPREVENTIVE_ACTION_FMEA__SACTION = eINSTANCE.getSPreventiveActionFMEA_SAction();

        /**
         * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SPREVENTIVE_ACTION_FMEA__ID = eINSTANCE.getSPreventiveActionFMEA_Id();

        /**
         * The meta object literal for the '<em><b>Base Property</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SPREVENTIVE_ACTION_FMEA__BASE_PROPERTY = eINSTANCE.getSPreventiveActionFMEA_Base_Property();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.SCauseFMEA <em>SCause FMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.SCauseFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSCauseFMEA()
         * @generated
         */
        EClass SCAUSE_FMEA = eINSTANCE.getSCauseFMEA();

        /**
         * The meta object literal for the '<em><b>SCause</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SCAUSE_FMEA__SCAUSE = eINSTANCE.getSCauseFMEA_SCause();

        /**
         * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute SCAUSE_FMEA__ID = eINSTANCE.getSCauseFMEA_Id();

        /**
         * The meta object literal for the '<em><b>Initial Occurence</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SCAUSE_FMEA__INITIAL_OCCURENCE = eINSTANCE.getSCauseFMEA_InitialOccurence();

        /**
         * The meta object literal for the '<em><b>Final Occurence</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SCAUSE_FMEA__FINAL_OCCURENCE = eINSTANCE.getSCauseFMEA_FinalOccurence();

        /**
         * The meta object literal for the '<em><b>Base Property</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SCAUSE_FMEA__BASE_PROPERTY = eINSTANCE.getSCauseFMEA_Base_Property();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.SSytemEffectFMEA <em>SSytem Effect FMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.SSytemEffectFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSSytemEffectFMEA()
         * @generated
         */
        EClass SSYTEM_EFFECT_FMEA = eINSTANCE.getSSytemEffectFMEA();

        /**
         * The meta object literal for the '<em><b>Base Property</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SSYTEM_EFFECT_FMEA__BASE_PROPERTY = eINSTANCE.getSSytemEffectFMEA_Base_Property();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.AbstractSEventEffectFMEA <em>Abstract SEvent Effect FMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.AbstractSEventEffectFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getAbstractSEventEffectFMEA()
         * @generated
         */
        EClass ABSTRACT_SEVENT_EFFECT_FMEA = eINSTANCE.getAbstractSEventEffectFMEA();

        /**
         * The meta object literal for the '<em><b>SEffect</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference ABSTRACT_SEVENT_EFFECT_FMEA__SEFFECT = eINSTANCE.getAbstractSEventEffectFMEA_SEffect();

        /**
         * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ABSTRACT_SEVENT_EFFECT_FMEA__ID = eINSTANCE.getAbstractSEventEffectFMEA_Id();

        /**
         * The meta object literal for the '<em><b>Severity</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference ABSTRACT_SEVENT_EFFECT_FMEA__SEVERITY = eINSTANCE.getAbstractSEventEffectFMEA_Severity();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.SCustomerEffectFMEA <em>SCustomer Effect FMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.SCustomerEffectFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSCustomerEffectFMEA()
         * @generated
         */
        EClass SCUSTOMER_EFFECT_FMEA = eINSTANCE.getSCustomerEffectFMEA();

        /**
         * The meta object literal for the '<em><b>Base Property</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SCUSTOMER_EFFECT_FMEA__BASE_PROPERTY = eINSTANCE.getSCustomerEffectFMEA_Base_Property();

        /**
         * The meta object literal for the '{@link org.polarsys.esf.esffmea.impl.SLocalEffectFMEA <em>SLocal Effect FMEA</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see org.polarsys.esf.esffmea.impl.SLocalEffectFMEA
         * @see org.polarsys.esf.esffmea.impl.ESFFMEAPackage#getSLocalEffectFMEA()
         * @generated
         */
        EClass SLOCAL_EFFECT_FMEA = eINSTANCE.getSLocalEffectFMEA();

        /**
         * The meta object literal for the '<em><b>Base Property</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SLOCAL_EFFECT_FMEA__BASE_PROPERTY = eINSTANCE.getSLocalEffectFMEA_Base_Property();

    }

} //IESFFMEAPackage
