/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea;

import org.eclipse.emf.common.util.EList;

import org.polarsys.esf.esfarchitectureconcepts.ISBlock;

import org.polarsys.esf.esfproperties.ISCriticality;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SBlock FMEA</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.polarsys.esf.esffmea.ISBlockFMEA#getSBlock <em>SBlock</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISBlockFMEA#getCriticality <em>Criticality</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISBlockFMEA#getDiagnosticCoverage <em>Diagnostic Coverage</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISBlockFMEA#getSsf <em>Ssf</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISBlockFMEA#getSFailureModeFMEA <em>SFailure Mode FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISBlockFMEA#getBase_Class <em>Base Class</em>}</li>
 * </ul>
 *
 * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSBlockFMEA()
 * @model
 * @generated
 */
public interface ISBlockFMEA extends IAbstractSFMEAElement {
    /**
     * Returns the value of the '<em><b>SBlock</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SBlock</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SBlock</em>' reference.
     * @see #setSBlock(ISBlock)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSBlockFMEA_SBlock()
     * @model required="true" ordered="false"
     * @generated
     */
    ISBlock getSBlock();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getSBlock <em>SBlock</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>SBlock</em>' reference.
     * @see #getSBlock()
     * @generated
     */
    void setSBlock(ISBlock value);

    /**
     * Returns the value of the '<em><b>Criticality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Criticality</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Criticality</em>' reference.
     * @see #setCriticality(ISCriticality)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSBlockFMEA_Criticality()
     * @model required="true" ordered="false"
     * @generated
     */
    ISCriticality getCriticality();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getCriticality <em>Criticality</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Criticality</em>' reference.
     * @see #getCriticality()
     * @generated
     */
    void setCriticality(ISCriticality value);

    /**
     * Returns the value of the '<em><b>Diagnostic Coverage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Diagnostic Coverage</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Diagnostic Coverage</em>' attribute.
     * @see #setDiagnosticCoverage(double)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSBlockFMEA_DiagnosticCoverage()
     * @model dataType="org.eclipse.uml2.types.Real" required="true" ordered="false"
     * @generated
     */
    double getDiagnosticCoverage();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getDiagnosticCoverage <em>Diagnostic Coverage</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Diagnostic Coverage</em>' attribute.
     * @see #getDiagnosticCoverage()
     * @generated
     */
    void setDiagnosticCoverage(double value);

    /**
     * Returns the value of the '<em><b>Ssf</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ssf</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Ssf</em>' attribute.
     * @see #setSsf(double)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSBlockFMEA_Ssf()
     * @model dataType="org.eclipse.uml2.types.Real" required="true" ordered="false"
     * @generated
     */
    double getSsf();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getSsf <em>Ssf</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Ssf</em>' attribute.
     * @see #getSsf()
     * @generated
     */
    void setSsf(double value);

    /**
     * Returns the value of the '<em><b>SFailure Mode FMEA</b></em>' reference list.
     * The list contents are of type {@link org.polarsys.esf.esffmea.ISFailureModeFMEA}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SFailure Mode FMEA</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SFailure Mode FMEA</em>' reference list.
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSBlockFMEA_SFailureModeFMEA()
     * @model ordered="false"
     * @generated
     */
    EList<ISFailureModeFMEA> getSFailureModeFMEA();

    /**
     * Returns the value of the '<em><b>Base Class</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Base Class</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Base Class</em>' reference.
     * @see #setBase_Class(org.eclipse.uml2.uml.Class)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSBlockFMEA_Base_Class()
     * @model required="true" ordered="false"
     * @generated
     */
    org.eclipse.uml2.uml.Class getBase_Class();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISBlockFMEA#getBase_Class <em>Base Class</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Base Class</em>' reference.
     * @see #getBase_Class()
     * @generated
     */
    void setBase_Class(org.eclipse.uml2.uml.Class value);

} // ISBlockFMEA
