/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea;

import org.eclipse.uml2.uml.Property;

import org.polarsys.esf.esfproperties.ISOccurence;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISCause;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SCause FMEA</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.polarsys.esf.esffmea.ISCauseFMEA#getSCause <em>SCause</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISCauseFMEA#getId <em>Id</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISCauseFMEA#getInitialOccurence <em>Initial Occurence</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISCauseFMEA#getFinalOccurence <em>Final Occurence</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISCauseFMEA#getBase_Property <em>Base Property</em>}</li>
 * </ul>
 *
 * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSCauseFMEA()
 * @model
 * @generated
 */
public interface ISCauseFMEA extends IAbstractSFMEAElement {
    /**
     * Returns the value of the '<em><b>SCause</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SCause</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SCause</em>' reference.
     * @see #setSCause(ISCause)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSCauseFMEA_SCause()
     * @model required="true" ordered="false"
     * @generated
     */
    ISCause getSCause();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getSCause <em>SCause</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>SCause</em>' reference.
     * @see #getSCause()
     * @generated
     */
    void setSCause(ISCause value);

    /**
     * Returns the value of the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Id</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Id</em>' attribute.
     * @see #setId(String)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSCauseFMEA_Id()
     * @model dataType="org.eclipse.uml2.types.String" required="true" ordered="false"
     * @generated
     */
    String getId();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getId <em>Id</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Id</em>' attribute.
     * @see #getId()
     * @generated
     */
    void setId(String value);

    /**
     * Returns the value of the '<em><b>Initial Occurence</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Initial Occurence</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Initial Occurence</em>' reference.
     * @see #setInitialOccurence(ISOccurence)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSCauseFMEA_InitialOccurence()
     * @model required="true" ordered="false"
     * @generated
     */
    ISOccurence getInitialOccurence();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getInitialOccurence <em>Initial Occurence</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Initial Occurence</em>' reference.
     * @see #getInitialOccurence()
     * @generated
     */
    void setInitialOccurence(ISOccurence value);

    /**
     * Returns the value of the '<em><b>Final Occurence</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Final Occurence</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Final Occurence</em>' reference.
     * @see #setFinalOccurence(ISOccurence)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSCauseFMEA_FinalOccurence()
     * @model required="true" ordered="false"
     * @generated
     */
    ISOccurence getFinalOccurence();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getFinalOccurence <em>Final Occurence</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Final Occurence</em>' reference.
     * @see #getFinalOccurence()
     * @generated
     */
    void setFinalOccurence(ISOccurence value);

    /**
     * Returns the value of the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Base Property</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Base Property</em>' reference.
     * @see #setBase_Property(Property)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSCauseFMEA_Base_Property()
     * @model required="true" ordered="false"
     * @generated
     */
    Property getBase_Property();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISCauseFMEA#getBase_Property <em>Base Property</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Base Property</em>' reference.
     * @see #getBase_Property()
     * @generated
     */
    void setBase_Property(Property value);

} // ISCauseFMEA
