/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea;

import org.eclipse.emf.common.util.EList;

import org.eclipse.uml2.uml.Property;

import org.polarsys.esf.esfproperties.ISCriticality;
import org.polarsys.esf.esfproperties.ISDetectability;
import org.polarsys.esf.esfproperties.ISOccurence;
import org.polarsys.esf.esfproperties.ISSeverity;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISFailureMode;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SFailure Mode FMEA</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSFailureMode <em>SFailure Mode</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getRemarks <em>Remarks</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSeverity <em>Severity</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getInitialCriticality <em>Initial Criticality</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFinalCriticality <em>Final Criticality</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#isSafe <em>Is Safe</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDiagnostics <em>Diagnostics</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFailureRate <em>Failure Rate</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getInitialCauseOccurence <em>Initial Cause Occurence</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFinalCauseOccurence <em>Final Cause Occurence</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getLocalEffectSeverity <em>Local Effect Severity</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSystemEffectSeverity <em>System Effect Severity</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getCustomerEffectSeverity <em>Customer Effect Severity</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDiagnostic_coverage <em>Diagnostic coverage</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSsf <em>Ssf</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#isDetectable <em>Is Detectable</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDetectability <em>Detectability</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSPreventiveActionFMEA <em>SPreventive Action FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSCauseFMEA <em>SCause FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSSystemEffectFMEA <em>SSystem Effect FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSCustomerEffectFMEA <em>SCustomer Effect FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSLocalEffectFMEA <em>SLocal Effect FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getBase_Property <em>Base Property</em>}</li>
 * </ul>
 *
 * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA()
 * @model
 * @generated
 */
public interface ISFailureModeFMEA extends IAbstractSFMEAElement {
    /**
     * Returns the value of the '<em><b>SFailure Mode</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SFailure Mode</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SFailure Mode</em>' reference.
     * @see #setSFailureMode(ISFailureMode)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_SFailureMode()
     * @model required="true" ordered="false"
     * @generated
     */
    ISFailureMode getSFailureMode();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSFailureMode <em>SFailure Mode</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>SFailure Mode</em>' reference.
     * @see #getSFailureMode()
     * @generated
     */
    void setSFailureMode(ISFailureMode value);

    /**
     * Returns the value of the '<em><b>Remarks</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Remarks</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Remarks</em>' attribute.
     * @see #setRemarks(String)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_Remarks()
     * @model dataType="org.eclipse.uml2.types.String" required="true" ordered="false"
     * @generated
     */
    String getRemarks();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getRemarks <em>Remarks</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Remarks</em>' attribute.
     * @see #getRemarks()
     * @generated
     */
    void setRemarks(String value);

    /**
     * Returns the value of the '<em><b>Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Severity</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Severity</em>' reference.
     * @see #setSeverity(ISSeverity)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_Severity()
     * @model required="true" ordered="false"
     * @generated
     */
    ISSeverity getSeverity();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSeverity <em>Severity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Severity</em>' reference.
     * @see #getSeverity()
     * @generated
     */
    void setSeverity(ISSeverity value);

    /**
     * Returns the value of the '<em><b>Initial Criticality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Initial Criticality</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Initial Criticality</em>' reference.
     * @see #setInitialCriticality(ISCriticality)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_InitialCriticality()
     * @model required="true" ordered="false"
     * @generated
     */
    ISCriticality getInitialCriticality();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getInitialCriticality <em>Initial Criticality</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Initial Criticality</em>' reference.
     * @see #getInitialCriticality()
     * @generated
     */
    void setInitialCriticality(ISCriticality value);

    /**
     * Returns the value of the '<em><b>Final Criticality</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Final Criticality</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Final Criticality</em>' reference.
     * @see #setFinalCriticality(ISCriticality)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_FinalCriticality()
     * @model required="true" ordered="false"
     * @generated
     */
    ISCriticality getFinalCriticality();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFinalCriticality <em>Final Criticality</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Final Criticality</em>' reference.
     * @see #getFinalCriticality()
     * @generated
     */
    void setFinalCriticality(ISCriticality value);

    /**
     * Returns the value of the '<em><b>Is Safe</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Is Safe</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Is Safe</em>' attribute.
     * @see #setIsSafe(boolean)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_IsSafe()
     * @model dataType="org.eclipse.uml2.types.Boolean" required="true" ordered="false"
     * @generated
     */
    boolean isSafe();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#isSafe <em>Is Safe</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Is Safe</em>' attribute.
     * @see #isSafe()
     * @generated
     */
    void setIsSafe(boolean value);

    /**
     * Returns the value of the '<em><b>Diagnostics</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Diagnostics</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Diagnostics</em>' attribute.
     * @see #setDiagnostics(String)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_Diagnostics()
     * @model dataType="org.eclipse.uml2.types.String" required="true" ordered="false"
     * @generated
     */
    String getDiagnostics();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDiagnostics <em>Diagnostics</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Diagnostics</em>' attribute.
     * @see #getDiagnostics()
     * @generated
     */
    void setDiagnostics(String value);

    /**
     * Returns the value of the '<em><b>Failure Rate</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Failure Rate</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Failure Rate</em>' attribute.
     * @see #setFailureRate(double)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_FailureRate()
     * @model dataType="org.eclipse.uml2.types.Real" required="true" ordered="false"
     * @generated
     */
    double getFailureRate();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFailureRate <em>Failure Rate</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Failure Rate</em>' attribute.
     * @see #getFailureRate()
     * @generated
     */
    void setFailureRate(double value);

    /**
     * Returns the value of the '<em><b>Initial Cause Occurence</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Initial Cause Occurence</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Initial Cause Occurence</em>' reference.
     * @see #setInitialCauseOccurence(ISOccurence)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_InitialCauseOccurence()
     * @model required="true" ordered="false"
     * @generated
     */
    ISOccurence getInitialCauseOccurence();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getInitialCauseOccurence <em>Initial Cause Occurence</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Initial Cause Occurence</em>' reference.
     * @see #getInitialCauseOccurence()
     * @generated
     */
    void setInitialCauseOccurence(ISOccurence value);

    /**
     * Returns the value of the '<em><b>Final Cause Occurence</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Final Cause Occurence</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Final Cause Occurence</em>' reference.
     * @see #setFinalCauseOccurence(ISOccurence)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_FinalCauseOccurence()
     * @model required="true" ordered="false"
     * @generated
     */
    ISOccurence getFinalCauseOccurence();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getFinalCauseOccurence <em>Final Cause Occurence</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Final Cause Occurence</em>' reference.
     * @see #getFinalCauseOccurence()
     * @generated
     */
    void setFinalCauseOccurence(ISOccurence value);

    /**
     * Returns the value of the '<em><b>Local Effect Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Local Effect Severity</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Local Effect Severity</em>' reference.
     * @see #setLocalEffectSeverity(ISSeverity)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_LocalEffectSeverity()
     * @model required="true" ordered="false"
     * @generated
     */
    ISSeverity getLocalEffectSeverity();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getLocalEffectSeverity <em>Local Effect Severity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Local Effect Severity</em>' reference.
     * @see #getLocalEffectSeverity()
     * @generated
     */
    void setLocalEffectSeverity(ISSeverity value);

    /**
     * Returns the value of the '<em><b>System Effect Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>System Effect Severity</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>System Effect Severity</em>' reference.
     * @see #setSystemEffectSeverity(ISSeverity)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_SystemEffectSeverity()
     * @model required="true" ordered="false"
     * @generated
     */
    ISSeverity getSystemEffectSeverity();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSystemEffectSeverity <em>System Effect Severity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>System Effect Severity</em>' reference.
     * @see #getSystemEffectSeverity()
     * @generated
     */
    void setSystemEffectSeverity(ISSeverity value);

    /**
     * Returns the value of the '<em><b>Customer Effect Severity</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Customer Effect Severity</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Customer Effect Severity</em>' reference.
     * @see #setCustomerEffectSeverity(ISSeverity)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_CustomerEffectSeverity()
     * @model required="true" ordered="false"
     * @generated
     */
    ISSeverity getCustomerEffectSeverity();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getCustomerEffectSeverity <em>Customer Effect Severity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Customer Effect Severity</em>' reference.
     * @see #getCustomerEffectSeverity()
     * @generated
     */
    void setCustomerEffectSeverity(ISSeverity value);

    /**
     * Returns the value of the '<em><b>Diagnostic coverage</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Diagnostic coverage</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Diagnostic coverage</em>' attribute.
     * @see #setDiagnostic_coverage(double)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_Diagnostic_coverage()
     * @model dataType="org.eclipse.uml2.types.Real" required="true" ordered="false"
     * @generated
     */
    double getDiagnostic_coverage();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDiagnostic_coverage <em>Diagnostic coverage</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Diagnostic coverage</em>' attribute.
     * @see #getDiagnostic_coverage()
     * @generated
     */
    void setDiagnostic_coverage(double value);

    /**
     * Returns the value of the '<em><b>Ssf</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Ssf</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Ssf</em>' attribute.
     * @see #setSsf(double)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_Ssf()
     * @model dataType="org.eclipse.uml2.types.Real" required="true" ordered="false"
     * @generated
     */
    double getSsf();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getSsf <em>Ssf</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Ssf</em>' attribute.
     * @see #getSsf()
     * @generated
     */
    void setSsf(double value);

    /**
     * Returns the value of the '<em><b>Is Detectable</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Is Detectable</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Is Detectable</em>' attribute.
     * @see #setIsDetectable(boolean)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_IsDetectable()
     * @model dataType="org.eclipse.uml2.types.Boolean" required="true" ordered="false"
     * @generated
     */
    boolean isDetectable();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#isDetectable <em>Is Detectable</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Is Detectable</em>' attribute.
     * @see #isDetectable()
     * @generated
     */
    void setIsDetectable(boolean value);

    /**
     * Returns the value of the '<em><b>Detectability</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Detectability</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Detectability</em>' reference.
     * @see #setDetectability(ISDetectability)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_Detectability()
     * @model required="true" ordered="false"
     * @generated
     */
    ISDetectability getDetectability();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getDetectability <em>Detectability</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Detectability</em>' reference.
     * @see #getDetectability()
     * @generated
     */
    void setDetectability(ISDetectability value);

    /**
     * Returns the value of the '<em><b>SPreventive Action FMEA</b></em>' reference list.
     * The list contents are of type {@link org.polarsys.esf.esffmea.ISPreventiveActionFMEA}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SPreventive Action FMEA</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SPreventive Action FMEA</em>' reference list.
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_SPreventiveActionFMEA()
     * @model ordered="false"
     * @generated
     */
    EList<ISPreventiveActionFMEA> getSPreventiveActionFMEA();

    /**
     * Returns the value of the '<em><b>SCause FMEA</b></em>' reference list.
     * The list contents are of type {@link org.polarsys.esf.esffmea.ISCauseFMEA}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SCause FMEA</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SCause FMEA</em>' reference list.
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_SCauseFMEA()
     * @model ordered="false"
     * @generated
     */
    EList<ISCauseFMEA> getSCauseFMEA();

    /**
     * Returns the value of the '<em><b>SSystem Effect FMEA</b></em>' reference list.
     * The list contents are of type {@link org.polarsys.esf.esffmea.ISSytemEffectFMEA}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SSystem Effect FMEA</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SSystem Effect FMEA</em>' reference list.
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_SSystemEffectFMEA()
     * @model ordered="false"
     * @generated
     */
    EList<ISSytemEffectFMEA> getSSystemEffectFMEA();

    /**
     * Returns the value of the '<em><b>SCustomer Effect FMEA</b></em>' reference list.
     * The list contents are of type {@link org.polarsys.esf.esffmea.ISCustomerEffectFMEA}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SCustomer Effect FMEA</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SCustomer Effect FMEA</em>' reference list.
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_SCustomerEffectFMEA()
     * @model ordered="false"
     * @generated
     */
    EList<ISCustomerEffectFMEA> getSCustomerEffectFMEA();

    /**
     * Returns the value of the '<em><b>SLocal Effect FMEA</b></em>' reference list.
     * The list contents are of type {@link org.polarsys.esf.esffmea.ISLocalEffectFMEA}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SLocal Effect FMEA</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>SLocal Effect FMEA</em>' reference list.
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_SLocalEffectFMEA()
     * @model ordered="false"
     * @generated
     */
    EList<ISLocalEffectFMEA> getSLocalEffectFMEA();

    /**
     * Returns the value of the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Base Property</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Base Property</em>' reference.
     * @see #setBase_Property(Property)
     * @see org.polarsys.esf.esffmea.IESFFMEAPackage#getSFailureModeFMEA_Base_Property()
     * @model required="true" ordered="false"
     * @generated
     */
    Property getBase_Property();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esffmea.ISFailureModeFMEA#getBase_Property <em>Base Property</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Base Property</em>' reference.
     * @see #getBase_Property()
     * @generated
     */
    void setBase_Property(Property value);

} // ISFailureModeFMEA
