/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.polarsys.esf.esffmea.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ESFFMEAFactory extends EFactoryImpl implements IESFFMEAFactory {
    /**
     * Creates the default factory implementation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static IESFFMEAFactory init() {
        try {
            IESFFMEAFactory theESFFMEAFactory = (IESFFMEAFactory)EPackage.Registry.INSTANCE.getEFactory(IESFFMEAPackage.eNS_URI);
            if (theESFFMEAFactory != null) {
                return theESFFMEAFactory;
            }
        }
        catch (Exception exception) {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new ESFFMEAFactory();
    }

    /**
     * Creates an instance of the factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ESFFMEAFactory() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EObject create(EClass eClass) {
        switch (eClass.getClassifierID()) {
            case IESFFMEAPackage.SFMEA: return createSFMEA();
            case IESFFMEAPackage.ABSTRACT_SFMEA_ELEMENT: return createAbstractSFMEAElement();
            case IESFFMEAPackage.SBLOCK_FMEA: return createSBlockFMEA();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA: return createSFailureModeFMEA();
            case IESFFMEAPackage.SPREVENTIVE_ACTION_FMEA: return createSPreventiveActionFMEA();
            case IESFFMEAPackage.SCAUSE_FMEA: return createSCauseFMEA();
            case IESFFMEAPackage.SSYTEM_EFFECT_FMEA: return createSSytemEffectFMEA();
            case IESFFMEAPackage.ABSTRACT_SEVENT_EFFECT_FMEA: return createAbstractSEventEffectFMEA();
            case IESFFMEAPackage.SCUSTOMER_EFFECT_FMEA: return createSCustomerEffectFMEA();
            case IESFFMEAPackage.SLOCAL_EFFECT_FMEA: return createSLocalEffectFMEA();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISFMEA createSFMEA() {
        SFMEA sfmea = new SFMEA();
        return sfmea;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public IAbstractSFMEAElement createAbstractSFMEAElement() {
        AbstractSFMEAElement abstractSFMEAElement = new AbstractSFMEAElement();
        return abstractSFMEAElement;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISBlockFMEA createSBlockFMEA() {
        SBlockFMEA sBlockFMEA = new SBlockFMEA();
        return sBlockFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISFailureModeFMEA createSFailureModeFMEA() {
        SFailureModeFMEA sFailureModeFMEA = new SFailureModeFMEA();
        return sFailureModeFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISPreventiveActionFMEA createSPreventiveActionFMEA() {
        SPreventiveActionFMEA sPreventiveActionFMEA = new SPreventiveActionFMEA();
        return sPreventiveActionFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCauseFMEA createSCauseFMEA() {
        SCauseFMEA sCauseFMEA = new SCauseFMEA();
        return sCauseFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSytemEffectFMEA createSSytemEffectFMEA() {
        SSytemEffectFMEA sSytemEffectFMEA = new SSytemEffectFMEA();
        return sSytemEffectFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public IAbstractSEventEffectFMEA createAbstractSEventEffectFMEA() {
        AbstractSEventEffectFMEA abstractSEventEffectFMEA = new AbstractSEventEffectFMEA();
        return abstractSEventEffectFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCustomerEffectFMEA createSCustomerEffectFMEA() {
        SCustomerEffectFMEA sCustomerEffectFMEA = new SCustomerEffectFMEA();
        return sCustomerEffectFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISLocalEffectFMEA createSLocalEffectFMEA() {
        SLocalEffectFMEA sLocalEffectFMEA = new SLocalEffectFMEA();
        return sLocalEffectFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public IESFFMEAPackage getESFFMEAPackage() {
        return (IESFFMEAPackage)getEPackage();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @deprecated
     * @generated
     */
    @Deprecated
    public static IESFFMEAPackage getPackage() {
        return IESFFMEAPackage.eINSTANCE;
    }

} //ESFFMEAFactory
