/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.polarsys.esf.esfarchitectureconcepts.ISBlock;

import org.polarsys.esf.esffmea.IESFFMEAPackage;
import org.polarsys.esf.esffmea.ISBlockFMEA;
import org.polarsys.esf.esffmea.ISFailureModeFMEA;

import org.polarsys.esf.esfproperties.ISCriticality;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SBlock FMEA</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SBlockFMEA#getSBlock <em>SBlock</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SBlockFMEA#getCriticality <em>Criticality</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SBlockFMEA#getDiagnosticCoverage <em>Diagnostic Coverage</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SBlockFMEA#getSsf <em>Ssf</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SBlockFMEA#getSFailureModeFMEA <em>SFailure Mode FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SBlockFMEA#getBase_Class <em>Base Class</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SBlockFMEA extends AbstractSFMEAElement implements ISBlockFMEA {
    /**
     * The cached value of the '{@link #getSBlock() <em>SBlock</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSBlock()
     * @generated
     * @ordered
     */
    protected ISBlock sBlock;

    /**
     * The cached value of the '{@link #getCriticality() <em>Criticality</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getCriticality()
     * @generated
     * @ordered
     */
    protected ISCriticality criticality;

    /**
     * The default value of the '{@link #getDiagnosticCoverage() <em>Diagnostic Coverage</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDiagnosticCoverage()
     * @generated
     * @ordered
     */
    protected static final double DIAGNOSTIC_COVERAGE_EDEFAULT = 0.0;

    /**
     * The cached value of the '{@link #getDiagnosticCoverage() <em>Diagnostic Coverage</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDiagnosticCoverage()
     * @generated
     * @ordered
     */
    protected double diagnosticCoverage = DIAGNOSTIC_COVERAGE_EDEFAULT;

    /**
     * The default value of the '{@link #getSsf() <em>Ssf</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSsf()
     * @generated
     * @ordered
     */
    protected static final double SSF_EDEFAULT = 0.0;

    /**
     * The cached value of the '{@link #getSsf() <em>Ssf</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSsf()
     * @generated
     * @ordered
     */
    protected double ssf = SSF_EDEFAULT;

    /**
     * The cached value of the '{@link #getSFailureModeFMEA() <em>SFailure Mode FMEA</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSFailureModeFMEA()
     * @generated
     * @ordered
     */
    protected EList<ISFailureModeFMEA> sFailureModeFMEA;

    /**
     * The cached value of the '{@link #getBase_Class() <em>Base Class</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getBase_Class()
     * @generated
     * @ordered
     */
    protected org.eclipse.uml2.uml.Class base_Class;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SBlockFMEA() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFFMEAPackage.Literals.SBLOCK_FMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISBlock getSBlock() {
        if (sBlock != null && sBlock.eIsProxy()) {
            InternalEObject oldSBlock = (InternalEObject)sBlock;
            sBlock = (ISBlock)eResolveProxy(oldSBlock);
            if (sBlock != oldSBlock) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SBLOCK_FMEA__SBLOCK, oldSBlock, sBlock));
            }
        }
        return sBlock;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISBlock basicGetSBlock() {
        return sBlock;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSBlock(ISBlock newSBlock) {
        ISBlock oldSBlock = sBlock;
        sBlock = newSBlock;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SBLOCK_FMEA__SBLOCK, oldSBlock, sBlock));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCriticality getCriticality() {
        if (criticality != null && criticality.eIsProxy()) {
            InternalEObject oldCriticality = (InternalEObject)criticality;
            criticality = (ISCriticality)eResolveProxy(oldCriticality);
            if (criticality != oldCriticality) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SBLOCK_FMEA__CRITICALITY, oldCriticality, criticality));
            }
        }
        return criticality;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCriticality basicGetCriticality() {
        return criticality;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setCriticality(ISCriticality newCriticality) {
        ISCriticality oldCriticality = criticality;
        criticality = newCriticality;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SBLOCK_FMEA__CRITICALITY, oldCriticality, criticality));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public double getDiagnosticCoverage() {
        return diagnosticCoverage;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setDiagnosticCoverage(double newDiagnosticCoverage) {
        double oldDiagnosticCoverage = diagnosticCoverage;
        diagnosticCoverage = newDiagnosticCoverage;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SBLOCK_FMEA__DIAGNOSTIC_COVERAGE, oldDiagnosticCoverage, diagnosticCoverage));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public double getSsf() {
        return ssf;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSsf(double newSsf) {
        double oldSsf = ssf;
        ssf = newSsf;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SBLOCK_FMEA__SSF, oldSsf, ssf));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<ISFailureModeFMEA> getSFailureModeFMEA() {
        if (sFailureModeFMEA == null) {
            sFailureModeFMEA = new EObjectResolvingEList<ISFailureModeFMEA>(ISFailureModeFMEA.class, this, IESFFMEAPackage.SBLOCK_FMEA__SFAILURE_MODE_FMEA);
        }
        return sFailureModeFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public org.eclipse.uml2.uml.Class getBase_Class() {
        if (base_Class != null && base_Class.eIsProxy()) {
            InternalEObject oldBase_Class = (InternalEObject)base_Class;
            base_Class = (org.eclipse.uml2.uml.Class)eResolveProxy(oldBase_Class);
            if (base_Class != oldBase_Class) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SBLOCK_FMEA__BASE_CLASS, oldBase_Class, base_Class));
            }
        }
        return base_Class;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public org.eclipse.uml2.uml.Class basicGetBase_Class() {
        return base_Class;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setBase_Class(org.eclipse.uml2.uml.Class newBase_Class) {
        org.eclipse.uml2.uml.Class oldBase_Class = base_Class;
        base_Class = newBase_Class;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SBLOCK_FMEA__BASE_CLASS, oldBase_Class, base_Class));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFFMEAPackage.SBLOCK_FMEA__SBLOCK:
                if (resolve) return getSBlock();
                return basicGetSBlock();
            case IESFFMEAPackage.SBLOCK_FMEA__CRITICALITY:
                if (resolve) return getCriticality();
                return basicGetCriticality();
            case IESFFMEAPackage.SBLOCK_FMEA__DIAGNOSTIC_COVERAGE:
                return getDiagnosticCoverage();
            case IESFFMEAPackage.SBLOCK_FMEA__SSF:
                return getSsf();
            case IESFFMEAPackage.SBLOCK_FMEA__SFAILURE_MODE_FMEA:
                return getSFailureModeFMEA();
            case IESFFMEAPackage.SBLOCK_FMEA__BASE_CLASS:
                if (resolve) return getBase_Class();
                return basicGetBase_Class();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFFMEAPackage.SBLOCK_FMEA__SBLOCK:
                setSBlock((ISBlock)newValue);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__CRITICALITY:
                setCriticality((ISCriticality)newValue);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__DIAGNOSTIC_COVERAGE:
                setDiagnosticCoverage((Double)newValue);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__SSF:
                setSsf((Double)newValue);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__SFAILURE_MODE_FMEA:
                getSFailureModeFMEA().clear();
                getSFailureModeFMEA().addAll((Collection<? extends ISFailureModeFMEA>)newValue);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__BASE_CLASS:
                setBase_Class((org.eclipse.uml2.uml.Class)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFFMEAPackage.SBLOCK_FMEA__SBLOCK:
                setSBlock((ISBlock)null);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__CRITICALITY:
                setCriticality((ISCriticality)null);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__DIAGNOSTIC_COVERAGE:
                setDiagnosticCoverage(DIAGNOSTIC_COVERAGE_EDEFAULT);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__SSF:
                setSsf(SSF_EDEFAULT);
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__SFAILURE_MODE_FMEA:
                getSFailureModeFMEA().clear();
                return;
            case IESFFMEAPackage.SBLOCK_FMEA__BASE_CLASS:
                setBase_Class((org.eclipse.uml2.uml.Class)null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFFMEAPackage.SBLOCK_FMEA__SBLOCK:
                return sBlock != null;
            case IESFFMEAPackage.SBLOCK_FMEA__CRITICALITY:
                return criticality != null;
            case IESFFMEAPackage.SBLOCK_FMEA__DIAGNOSTIC_COVERAGE:
                return diagnosticCoverage != DIAGNOSTIC_COVERAGE_EDEFAULT;
            case IESFFMEAPackage.SBLOCK_FMEA__SSF:
                return ssf != SSF_EDEFAULT;
            case IESFFMEAPackage.SBLOCK_FMEA__SFAILURE_MODE_FMEA:
                return sFailureModeFMEA != null && !sFailureModeFMEA.isEmpty();
            case IESFFMEAPackage.SBLOCK_FMEA__BASE_CLASS:
                return base_Class != null;
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (diagnosticCoverage: ");
        result.append(diagnosticCoverage);
        result.append(", ssf: ");
        result.append(ssf);
        result.append(')');
        return result.toString();
    }

} //SBlockFMEA
