/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.uml2.uml.Property;

import org.polarsys.esf.esffmea.IESFFMEAPackage;
import org.polarsys.esf.esffmea.ISCauseFMEA;

import org.polarsys.esf.esfproperties.ISOccurence;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISCause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SCause FMEA</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SCauseFMEA#getSCause <em>SCause</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SCauseFMEA#getId <em>Id</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SCauseFMEA#getInitialOccurence <em>Initial Occurence</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SCauseFMEA#getFinalOccurence <em>Final Occurence</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SCauseFMEA#getBase_Property <em>Base Property</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SCauseFMEA extends AbstractSFMEAElement implements ISCauseFMEA {
    /**
     * The cached value of the '{@link #getSCause() <em>SCause</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSCause()
     * @generated
     * @ordered
     */
    protected ISCause sCause;

    /**
     * The default value of the '{@link #getId() <em>Id</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getId()
     * @generated
     * @ordered
     */
    protected static final String ID_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getId()
     * @generated
     * @ordered
     */
    protected String id = ID_EDEFAULT;

    /**
     * The cached value of the '{@link #getInitialOccurence() <em>Initial Occurence</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getInitialOccurence()
     * @generated
     * @ordered
     */
    protected ISOccurence initialOccurence;

    /**
     * The cached value of the '{@link #getFinalOccurence() <em>Final Occurence</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFinalOccurence()
     * @generated
     * @ordered
     */
    protected ISOccurence finalOccurence;

    /**
     * The cached value of the '{@link #getBase_Property() <em>Base Property</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getBase_Property()
     * @generated
     * @ordered
     */
    protected Property base_Property;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SCauseFMEA() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFFMEAPackage.Literals.SCAUSE_FMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCause getSCause() {
        if (sCause != null && sCause.eIsProxy()) {
            InternalEObject oldSCause = (InternalEObject)sCause;
            sCause = (ISCause)eResolveProxy(oldSCause);
            if (sCause != oldSCause) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SCAUSE_FMEA__SCAUSE, oldSCause, sCause));
            }
        }
        return sCause;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCause basicGetSCause() {
        return sCause;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSCause(ISCause newSCause) {
        ISCause oldSCause = sCause;
        sCause = newSCause;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SCAUSE_FMEA__SCAUSE, oldSCause, sCause));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String getId() {
        return id;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setId(String newId) {
        String oldId = id;
        id = newId;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SCAUSE_FMEA__ID, oldId, id));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISOccurence getInitialOccurence() {
        if (initialOccurence != null && initialOccurence.eIsProxy()) {
            InternalEObject oldInitialOccurence = (InternalEObject)initialOccurence;
            initialOccurence = (ISOccurence)eResolveProxy(oldInitialOccurence);
            if (initialOccurence != oldInitialOccurence) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SCAUSE_FMEA__INITIAL_OCCURENCE, oldInitialOccurence, initialOccurence));
            }
        }
        return initialOccurence;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISOccurence basicGetInitialOccurence() {
        return initialOccurence;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setInitialOccurence(ISOccurence newInitialOccurence) {
        ISOccurence oldInitialOccurence = initialOccurence;
        initialOccurence = newInitialOccurence;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SCAUSE_FMEA__INITIAL_OCCURENCE, oldInitialOccurence, initialOccurence));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISOccurence getFinalOccurence() {
        if (finalOccurence != null && finalOccurence.eIsProxy()) {
            InternalEObject oldFinalOccurence = (InternalEObject)finalOccurence;
            finalOccurence = (ISOccurence)eResolveProxy(oldFinalOccurence);
            if (finalOccurence != oldFinalOccurence) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SCAUSE_FMEA__FINAL_OCCURENCE, oldFinalOccurence, finalOccurence));
            }
        }
        return finalOccurence;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISOccurence basicGetFinalOccurence() {
        return finalOccurence;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setFinalOccurence(ISOccurence newFinalOccurence) {
        ISOccurence oldFinalOccurence = finalOccurence;
        finalOccurence = newFinalOccurence;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SCAUSE_FMEA__FINAL_OCCURENCE, oldFinalOccurence, finalOccurence));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Property getBase_Property() {
        if (base_Property != null && base_Property.eIsProxy()) {
            InternalEObject oldBase_Property = (InternalEObject)base_Property;
            base_Property = (Property)eResolveProxy(oldBase_Property);
            if (base_Property != oldBase_Property) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SCAUSE_FMEA__BASE_PROPERTY, oldBase_Property, base_Property));
            }
        }
        return base_Property;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Property basicGetBase_Property() {
        return base_Property;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setBase_Property(Property newBase_Property) {
        Property oldBase_Property = base_Property;
        base_Property = newBase_Property;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SCAUSE_FMEA__BASE_PROPERTY, oldBase_Property, base_Property));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFFMEAPackage.SCAUSE_FMEA__SCAUSE:
                if (resolve) return getSCause();
                return basicGetSCause();
            case IESFFMEAPackage.SCAUSE_FMEA__ID:
                return getId();
            case IESFFMEAPackage.SCAUSE_FMEA__INITIAL_OCCURENCE:
                if (resolve) return getInitialOccurence();
                return basicGetInitialOccurence();
            case IESFFMEAPackage.SCAUSE_FMEA__FINAL_OCCURENCE:
                if (resolve) return getFinalOccurence();
                return basicGetFinalOccurence();
            case IESFFMEAPackage.SCAUSE_FMEA__BASE_PROPERTY:
                if (resolve) return getBase_Property();
                return basicGetBase_Property();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFFMEAPackage.SCAUSE_FMEA__SCAUSE:
                setSCause((ISCause)newValue);
                return;
            case IESFFMEAPackage.SCAUSE_FMEA__ID:
                setId((String)newValue);
                return;
            case IESFFMEAPackage.SCAUSE_FMEA__INITIAL_OCCURENCE:
                setInitialOccurence((ISOccurence)newValue);
                return;
            case IESFFMEAPackage.SCAUSE_FMEA__FINAL_OCCURENCE:
                setFinalOccurence((ISOccurence)newValue);
                return;
            case IESFFMEAPackage.SCAUSE_FMEA__BASE_PROPERTY:
                setBase_Property((Property)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFFMEAPackage.SCAUSE_FMEA__SCAUSE:
                setSCause((ISCause)null);
                return;
            case IESFFMEAPackage.SCAUSE_FMEA__ID:
                setId(ID_EDEFAULT);
                return;
            case IESFFMEAPackage.SCAUSE_FMEA__INITIAL_OCCURENCE:
                setInitialOccurence((ISOccurence)null);
                return;
            case IESFFMEAPackage.SCAUSE_FMEA__FINAL_OCCURENCE:
                setFinalOccurence((ISOccurence)null);
                return;
            case IESFFMEAPackage.SCAUSE_FMEA__BASE_PROPERTY:
                setBase_Property((Property)null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFFMEAPackage.SCAUSE_FMEA__SCAUSE:
                return sCause != null;
            case IESFFMEAPackage.SCAUSE_FMEA__ID:
                return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
            case IESFFMEAPackage.SCAUSE_FMEA__INITIAL_OCCURENCE:
                return initialOccurence != null;
            case IESFFMEAPackage.SCAUSE_FMEA__FINAL_OCCURENCE:
                return finalOccurence != null;
            case IESFFMEAPackage.SCAUSE_FMEA__BASE_PROPERTY:
                return base_Property != null;
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (id: ");
        result.append(id);
        result.append(')');
        return result.toString();
    }

} //SCauseFMEA
