/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.eclipse.uml2.uml.Property;

import org.polarsys.esf.esffmea.IESFFMEAPackage;
import org.polarsys.esf.esffmea.ISCauseFMEA;
import org.polarsys.esf.esffmea.ISCustomerEffectFMEA;
import org.polarsys.esf.esffmea.ISFailureModeFMEA;
import org.polarsys.esf.esffmea.ISLocalEffectFMEA;
import org.polarsys.esf.esffmea.ISPreventiveActionFMEA;
import org.polarsys.esf.esffmea.ISSytemEffectFMEA;

import org.polarsys.esf.esfproperties.ISCriticality;
import org.polarsys.esf.esfproperties.ISDetectability;
import org.polarsys.esf.esfproperties.ISOccurence;
import org.polarsys.esf.esfproperties.ISSeverity;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISFailureMode;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SFailure Mode FMEA</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSFailureMode <em>SFailure Mode</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getRemarks <em>Remarks</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSeverity <em>Severity</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getInitialCriticality <em>Initial Criticality</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getFinalCriticality <em>Final Criticality</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#isSafe <em>Is Safe</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getDiagnostics <em>Diagnostics</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getFailureRate <em>Failure Rate</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getInitialCauseOccurence <em>Initial Cause Occurence</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getFinalCauseOccurence <em>Final Cause Occurence</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getLocalEffectSeverity <em>Local Effect Severity</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSystemEffectSeverity <em>System Effect Severity</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getCustomerEffectSeverity <em>Customer Effect Severity</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getDiagnostic_coverage <em>Diagnostic coverage</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSsf <em>Ssf</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#isDetectable <em>Is Detectable</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getDetectability <em>Detectability</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSPreventiveActionFMEA <em>SPreventive Action FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSCauseFMEA <em>SCause FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSSystemEffectFMEA <em>SSystem Effect FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSCustomerEffectFMEA <em>SCustomer Effect FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getSLocalEffectFMEA <em>SLocal Effect FMEA</em>}</li>
 *   <li>{@link org.polarsys.esf.esffmea.impl.SFailureModeFMEA#getBase_Property <em>Base Property</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SFailureModeFMEA extends AbstractSFMEAElement implements ISFailureModeFMEA {
    /**
     * The cached value of the '{@link #getSFailureMode() <em>SFailure Mode</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSFailureMode()
     * @generated
     * @ordered
     */
    protected ISFailureMode sFailureMode;

    /**
     * The default value of the '{@link #getRemarks() <em>Remarks</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getRemarks()
     * @generated
     * @ordered
     */
    protected static final String REMARKS_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getRemarks() <em>Remarks</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getRemarks()
     * @generated
     * @ordered
     */
    protected String remarks = REMARKS_EDEFAULT;

    /**
     * The cached value of the '{@link #getSeverity() <em>Severity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSeverity()
     * @generated
     * @ordered
     */
    protected ISSeverity severity;

    /**
     * The cached value of the '{@link #getInitialCriticality() <em>Initial Criticality</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getInitialCriticality()
     * @generated
     * @ordered
     */
    protected ISCriticality initialCriticality;

    /**
     * The cached value of the '{@link #getFinalCriticality() <em>Final Criticality</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFinalCriticality()
     * @generated
     * @ordered
     */
    protected ISCriticality finalCriticality;

    /**
     * The default value of the '{@link #isSafe() <em>Is Safe</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSafe()
     * @generated
     * @ordered
     */
    protected static final boolean IS_SAFE_EDEFAULT = false;

    /**
     * The cached value of the '{@link #isSafe() <em>Is Safe</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isSafe()
     * @generated
     * @ordered
     */
    protected boolean isSafe = IS_SAFE_EDEFAULT;

    /**
     * The default value of the '{@link #getDiagnostics() <em>Diagnostics</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDiagnostics()
     * @generated
     * @ordered
     */
    protected static final String DIAGNOSTICS_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getDiagnostics() <em>Diagnostics</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDiagnostics()
     * @generated
     * @ordered
     */
    protected String diagnostics = DIAGNOSTICS_EDEFAULT;

    /**
     * The default value of the '{@link #getFailureRate() <em>Failure Rate</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFailureRate()
     * @generated
     * @ordered
     */
    protected static final double FAILURE_RATE_EDEFAULT = 0.0;

    /**
     * The cached value of the '{@link #getFailureRate() <em>Failure Rate</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFailureRate()
     * @generated
     * @ordered
     */
    protected double failureRate = FAILURE_RATE_EDEFAULT;

    /**
     * The cached value of the '{@link #getInitialCauseOccurence() <em>Initial Cause Occurence</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getInitialCauseOccurence()
     * @generated
     * @ordered
     */
    protected ISOccurence initialCauseOccurence;

    /**
     * The cached value of the '{@link #getFinalCauseOccurence() <em>Final Cause Occurence</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFinalCauseOccurence()
     * @generated
     * @ordered
     */
    protected ISOccurence finalCauseOccurence;

    /**
     * The cached value of the '{@link #getLocalEffectSeverity() <em>Local Effect Severity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getLocalEffectSeverity()
     * @generated
     * @ordered
     */
    protected ISSeverity localEffectSeverity;

    /**
     * The cached value of the '{@link #getSystemEffectSeverity() <em>System Effect Severity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSystemEffectSeverity()
     * @generated
     * @ordered
     */
    protected ISSeverity systemEffectSeverity;

    /**
     * The cached value of the '{@link #getCustomerEffectSeverity() <em>Customer Effect Severity</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getCustomerEffectSeverity()
     * @generated
     * @ordered
     */
    protected ISSeverity customerEffectSeverity;

    /**
     * The default value of the '{@link #getDiagnostic_coverage() <em>Diagnostic coverage</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDiagnostic_coverage()
     * @generated
     * @ordered
     */
    protected static final double DIAGNOSTIC_COVERAGE_EDEFAULT = 0.0;

    /**
     * The cached value of the '{@link #getDiagnostic_coverage() <em>Diagnostic coverage</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDiagnostic_coverage()
     * @generated
     * @ordered
     */
    protected double diagnostic_coverage = DIAGNOSTIC_COVERAGE_EDEFAULT;

    /**
     * The default value of the '{@link #getSsf() <em>Ssf</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSsf()
     * @generated
     * @ordered
     */
    protected static final double SSF_EDEFAULT = 0.0;

    /**
     * The cached value of the '{@link #getSsf() <em>Ssf</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSsf()
     * @generated
     * @ordered
     */
    protected double ssf = SSF_EDEFAULT;

    /**
     * The default value of the '{@link #isDetectable() <em>Is Detectable</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isDetectable()
     * @generated
     * @ordered
     */
    protected static final boolean IS_DETECTABLE_EDEFAULT = false;

    /**
     * The cached value of the '{@link #isDetectable() <em>Is Detectable</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #isDetectable()
     * @generated
     * @ordered
     */
    protected boolean isDetectable = IS_DETECTABLE_EDEFAULT;

    /**
     * The cached value of the '{@link #getDetectability() <em>Detectability</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDetectability()
     * @generated
     * @ordered
     */
    protected ISDetectability detectability;

    /**
     * The cached value of the '{@link #getSPreventiveActionFMEA() <em>SPreventive Action FMEA</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSPreventiveActionFMEA()
     * @generated
     * @ordered
     */
    protected EList<ISPreventiveActionFMEA> sPreventiveActionFMEA;

    /**
     * The cached value of the '{@link #getSCauseFMEA() <em>SCause FMEA</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSCauseFMEA()
     * @generated
     * @ordered
     */
    protected EList<ISCauseFMEA> sCauseFMEA;

    /**
     * The cached value of the '{@link #getSSystemEffectFMEA() <em>SSystem Effect FMEA</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSSystemEffectFMEA()
     * @generated
     * @ordered
     */
    protected EList<ISSytemEffectFMEA> sSystemEffectFMEA;

    /**
     * The cached value of the '{@link #getSCustomerEffectFMEA() <em>SCustomer Effect FMEA</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSCustomerEffectFMEA()
     * @generated
     * @ordered
     */
    protected EList<ISCustomerEffectFMEA> sCustomerEffectFMEA;

    /**
     * The cached value of the '{@link #getSLocalEffectFMEA() <em>SLocal Effect FMEA</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSLocalEffectFMEA()
     * @generated
     * @ordered
     */
    protected EList<ISLocalEffectFMEA> sLocalEffectFMEA;

    /**
     * The cached value of the '{@link #getBase_Property() <em>Base Property</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getBase_Property()
     * @generated
     * @ordered
     */
    protected Property base_Property;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SFailureModeFMEA() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFFMEAPackage.Literals.SFAILURE_MODE_FMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISFailureMode getSFailureMode() {
        if (sFailureMode != null && sFailureMode.eIsProxy()) {
            InternalEObject oldSFailureMode = (InternalEObject)sFailureMode;
            sFailureMode = (ISFailureMode)eResolveProxy(oldSFailureMode);
            if (sFailureMode != oldSFailureMode) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__SFAILURE_MODE, oldSFailureMode, sFailureMode));
            }
        }
        return sFailureMode;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISFailureMode basicGetSFailureMode() {
        return sFailureMode;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSFailureMode(ISFailureMode newSFailureMode) {
        ISFailureMode oldSFailureMode = sFailureMode;
        sFailureMode = newSFailureMode;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__SFAILURE_MODE, oldSFailureMode, sFailureMode));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String getRemarks() {
        return remarks;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setRemarks(String newRemarks) {
        String oldRemarks = remarks;
        remarks = newRemarks;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__REMARKS, oldRemarks, remarks));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSeverity getSeverity() {
        if (severity != null && severity.eIsProxy()) {
            InternalEObject oldSeverity = (InternalEObject)severity;
            severity = (ISSeverity)eResolveProxy(oldSeverity);
            if (severity != oldSeverity) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__SEVERITY, oldSeverity, severity));
            }
        }
        return severity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSeverity basicGetSeverity() {
        return severity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSeverity(ISSeverity newSeverity) {
        ISSeverity oldSeverity = severity;
        severity = newSeverity;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__SEVERITY, oldSeverity, severity));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCriticality getInitialCriticality() {
        if (initialCriticality != null && initialCriticality.eIsProxy()) {
            InternalEObject oldInitialCriticality = (InternalEObject)initialCriticality;
            initialCriticality = (ISCriticality)eResolveProxy(oldInitialCriticality);
            if (initialCriticality != oldInitialCriticality) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CRITICALITY, oldInitialCriticality, initialCriticality));
            }
        }
        return initialCriticality;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCriticality basicGetInitialCriticality() {
        return initialCriticality;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setInitialCriticality(ISCriticality newInitialCriticality) {
        ISCriticality oldInitialCriticality = initialCriticality;
        initialCriticality = newInitialCriticality;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CRITICALITY, oldInitialCriticality, initialCriticality));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCriticality getFinalCriticality() {
        if (finalCriticality != null && finalCriticality.eIsProxy()) {
            InternalEObject oldFinalCriticality = (InternalEObject)finalCriticality;
            finalCriticality = (ISCriticality)eResolveProxy(oldFinalCriticality);
            if (finalCriticality != oldFinalCriticality) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CRITICALITY, oldFinalCriticality, finalCriticality));
            }
        }
        return finalCriticality;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISCriticality basicGetFinalCriticality() {
        return finalCriticality;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setFinalCriticality(ISCriticality newFinalCriticality) {
        ISCriticality oldFinalCriticality = finalCriticality;
        finalCriticality = newFinalCriticality;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CRITICALITY, oldFinalCriticality, finalCriticality));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isSafe() {
        return isSafe;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setIsSafe(boolean newIsSafe) {
        boolean oldIsSafe = isSafe;
        isSafe = newIsSafe;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_SAFE, oldIsSafe, isSafe));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String getDiagnostics() {
        return diagnostics;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setDiagnostics(String newDiagnostics) {
        String oldDiagnostics = diagnostics;
        diagnostics = newDiagnostics;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTICS, oldDiagnostics, diagnostics));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public double getFailureRate() {
        return failureRate;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setFailureRate(double newFailureRate) {
        double oldFailureRate = failureRate;
        failureRate = newFailureRate;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__FAILURE_RATE, oldFailureRate, failureRate));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISOccurence getInitialCauseOccurence() {
        if (initialCauseOccurence != null && initialCauseOccurence.eIsProxy()) {
            InternalEObject oldInitialCauseOccurence = (InternalEObject)initialCauseOccurence;
            initialCauseOccurence = (ISOccurence)eResolveProxy(oldInitialCauseOccurence);
            if (initialCauseOccurence != oldInitialCauseOccurence) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CAUSE_OCCURENCE, oldInitialCauseOccurence, initialCauseOccurence));
            }
        }
        return initialCauseOccurence;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISOccurence basicGetInitialCauseOccurence() {
        return initialCauseOccurence;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setInitialCauseOccurence(ISOccurence newInitialCauseOccurence) {
        ISOccurence oldInitialCauseOccurence = initialCauseOccurence;
        initialCauseOccurence = newInitialCauseOccurence;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CAUSE_OCCURENCE, oldInitialCauseOccurence, initialCauseOccurence));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISOccurence getFinalCauseOccurence() {
        if (finalCauseOccurence != null && finalCauseOccurence.eIsProxy()) {
            InternalEObject oldFinalCauseOccurence = (InternalEObject)finalCauseOccurence;
            finalCauseOccurence = (ISOccurence)eResolveProxy(oldFinalCauseOccurence);
            if (finalCauseOccurence != oldFinalCauseOccurence) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CAUSE_OCCURENCE, oldFinalCauseOccurence, finalCauseOccurence));
            }
        }
        return finalCauseOccurence;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISOccurence basicGetFinalCauseOccurence() {
        return finalCauseOccurence;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setFinalCauseOccurence(ISOccurence newFinalCauseOccurence) {
        ISOccurence oldFinalCauseOccurence = finalCauseOccurence;
        finalCauseOccurence = newFinalCauseOccurence;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CAUSE_OCCURENCE, oldFinalCauseOccurence, finalCauseOccurence));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSeverity getLocalEffectSeverity() {
        if (localEffectSeverity != null && localEffectSeverity.eIsProxy()) {
            InternalEObject oldLocalEffectSeverity = (InternalEObject)localEffectSeverity;
            localEffectSeverity = (ISSeverity)eResolveProxy(oldLocalEffectSeverity);
            if (localEffectSeverity != oldLocalEffectSeverity) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__LOCAL_EFFECT_SEVERITY, oldLocalEffectSeverity, localEffectSeverity));
            }
        }
        return localEffectSeverity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSeverity basicGetLocalEffectSeverity() {
        return localEffectSeverity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setLocalEffectSeverity(ISSeverity newLocalEffectSeverity) {
        ISSeverity oldLocalEffectSeverity = localEffectSeverity;
        localEffectSeverity = newLocalEffectSeverity;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__LOCAL_EFFECT_SEVERITY, oldLocalEffectSeverity, localEffectSeverity));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSeverity getSystemEffectSeverity() {
        if (systemEffectSeverity != null && systemEffectSeverity.eIsProxy()) {
            InternalEObject oldSystemEffectSeverity = (InternalEObject)systemEffectSeverity;
            systemEffectSeverity = (ISSeverity)eResolveProxy(oldSystemEffectSeverity);
            if (systemEffectSeverity != oldSystemEffectSeverity) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__SYSTEM_EFFECT_SEVERITY, oldSystemEffectSeverity, systemEffectSeverity));
            }
        }
        return systemEffectSeverity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSeverity basicGetSystemEffectSeverity() {
        return systemEffectSeverity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSystemEffectSeverity(ISSeverity newSystemEffectSeverity) {
        ISSeverity oldSystemEffectSeverity = systemEffectSeverity;
        systemEffectSeverity = newSystemEffectSeverity;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__SYSTEM_EFFECT_SEVERITY, oldSystemEffectSeverity, systemEffectSeverity));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSeverity getCustomerEffectSeverity() {
        if (customerEffectSeverity != null && customerEffectSeverity.eIsProxy()) {
            InternalEObject oldCustomerEffectSeverity = (InternalEObject)customerEffectSeverity;
            customerEffectSeverity = (ISSeverity)eResolveProxy(oldCustomerEffectSeverity);
            if (customerEffectSeverity != oldCustomerEffectSeverity) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__CUSTOMER_EFFECT_SEVERITY, oldCustomerEffectSeverity, customerEffectSeverity));
            }
        }
        return customerEffectSeverity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISSeverity basicGetCustomerEffectSeverity() {
        return customerEffectSeverity;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setCustomerEffectSeverity(ISSeverity newCustomerEffectSeverity) {
        ISSeverity oldCustomerEffectSeverity = customerEffectSeverity;
        customerEffectSeverity = newCustomerEffectSeverity;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__CUSTOMER_EFFECT_SEVERITY, oldCustomerEffectSeverity, customerEffectSeverity));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public double getDiagnostic_coverage() {
        return diagnostic_coverage;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setDiagnostic_coverage(double newDiagnostic_coverage) {
        double oldDiagnostic_coverage = diagnostic_coverage;
        diagnostic_coverage = newDiagnostic_coverage;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTIC_COVERAGE, oldDiagnostic_coverage, diagnostic_coverage));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public double getSsf() {
        return ssf;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSsf(double newSsf) {
        double oldSsf = ssf;
        ssf = newSsf;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__SSF, oldSsf, ssf));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean isDetectable() {
        return isDetectable;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setIsDetectable(boolean newIsDetectable) {
        boolean oldIsDetectable = isDetectable;
        isDetectable = newIsDetectable;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_DETECTABLE, oldIsDetectable, isDetectable));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISDetectability getDetectability() {
        if (detectability != null && detectability.eIsProxy()) {
            InternalEObject oldDetectability = (InternalEObject)detectability;
            detectability = (ISDetectability)eResolveProxy(oldDetectability);
            if (detectability != oldDetectability) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__DETECTABILITY, oldDetectability, detectability));
            }
        }
        return detectability;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ISDetectability basicGetDetectability() {
        return detectability;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setDetectability(ISDetectability newDetectability) {
        ISDetectability oldDetectability = detectability;
        detectability = newDetectability;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__DETECTABILITY, oldDetectability, detectability));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<ISPreventiveActionFMEA> getSPreventiveActionFMEA() {
        if (sPreventiveActionFMEA == null) {
            sPreventiveActionFMEA = new EObjectResolvingEList<ISPreventiveActionFMEA>(ISPreventiveActionFMEA.class, this, IESFFMEAPackage.SFAILURE_MODE_FMEA__SPREVENTIVE_ACTION_FMEA);
        }
        return sPreventiveActionFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<ISCauseFMEA> getSCauseFMEA() {
        if (sCauseFMEA == null) {
            sCauseFMEA = new EObjectResolvingEList<ISCauseFMEA>(ISCauseFMEA.class, this, IESFFMEAPackage.SFAILURE_MODE_FMEA__SCAUSE_FMEA);
        }
        return sCauseFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<ISSytemEffectFMEA> getSSystemEffectFMEA() {
        if (sSystemEffectFMEA == null) {
            sSystemEffectFMEA = new EObjectResolvingEList<ISSytemEffectFMEA>(ISSytemEffectFMEA.class, this, IESFFMEAPackage.SFAILURE_MODE_FMEA__SSYSTEM_EFFECT_FMEA);
        }
        return sSystemEffectFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<ISCustomerEffectFMEA> getSCustomerEffectFMEA() {
        if (sCustomerEffectFMEA == null) {
            sCustomerEffectFMEA = new EObjectResolvingEList<ISCustomerEffectFMEA>(ISCustomerEffectFMEA.class, this, IESFFMEAPackage.SFAILURE_MODE_FMEA__SCUSTOMER_EFFECT_FMEA);
        }
        return sCustomerEffectFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList<ISLocalEffectFMEA> getSLocalEffectFMEA() {
        if (sLocalEffectFMEA == null) {
            sLocalEffectFMEA = new EObjectResolvingEList<ISLocalEffectFMEA>(ISLocalEffectFMEA.class, this, IESFFMEAPackage.SFAILURE_MODE_FMEA__SLOCAL_EFFECT_FMEA);
        }
        return sLocalEffectFMEA;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Property getBase_Property() {
        if (base_Property != null && base_Property.eIsProxy()) {
            InternalEObject oldBase_Property = (InternalEObject)base_Property;
            base_Property = (Property)eResolveProxy(oldBase_Property);
            if (base_Property != oldBase_Property) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, IESFFMEAPackage.SFAILURE_MODE_FMEA__BASE_PROPERTY, oldBase_Property, base_Property));
            }
        }
        return base_Property;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Property basicGetBase_Property() {
        return base_Property;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setBase_Property(Property newBase_Property) {
        Property oldBase_Property = base_Property;
        base_Property = newBase_Property;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, IESFFMEAPackage.SFAILURE_MODE_FMEA__BASE_PROPERTY, oldBase_Property, base_Property));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SFAILURE_MODE:
                if (resolve) return getSFailureMode();
                return basicGetSFailureMode();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__REMARKS:
                return getRemarks();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SEVERITY:
                if (resolve) return getSeverity();
                return basicGetSeverity();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CRITICALITY:
                if (resolve) return getInitialCriticality();
                return basicGetInitialCriticality();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CRITICALITY:
                if (resolve) return getFinalCriticality();
                return basicGetFinalCriticality();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_SAFE:
                return isSafe();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTICS:
                return getDiagnostics();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FAILURE_RATE:
                return getFailureRate();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CAUSE_OCCURENCE:
                if (resolve) return getInitialCauseOccurence();
                return basicGetInitialCauseOccurence();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CAUSE_OCCURENCE:
                if (resolve) return getFinalCauseOccurence();
                return basicGetFinalCauseOccurence();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__LOCAL_EFFECT_SEVERITY:
                if (resolve) return getLocalEffectSeverity();
                return basicGetLocalEffectSeverity();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SYSTEM_EFFECT_SEVERITY:
                if (resolve) return getSystemEffectSeverity();
                return basicGetSystemEffectSeverity();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__CUSTOMER_EFFECT_SEVERITY:
                if (resolve) return getCustomerEffectSeverity();
                return basicGetCustomerEffectSeverity();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTIC_COVERAGE:
                return getDiagnostic_coverage();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SSF:
                return getSsf();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_DETECTABLE:
                return isDetectable();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DETECTABILITY:
                if (resolve) return getDetectability();
                return basicGetDetectability();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SPREVENTIVE_ACTION_FMEA:
                return getSPreventiveActionFMEA();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SCAUSE_FMEA:
                return getSCauseFMEA();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SSYSTEM_EFFECT_FMEA:
                return getSSystemEffectFMEA();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SCUSTOMER_EFFECT_FMEA:
                return getSCustomerEffectFMEA();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SLOCAL_EFFECT_FMEA:
                return getSLocalEffectFMEA();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__BASE_PROPERTY:
                if (resolve) return getBase_Property();
                return basicGetBase_Property();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SFAILURE_MODE:
                setSFailureMode((ISFailureMode)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__REMARKS:
                setRemarks((String)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SEVERITY:
                setSeverity((ISSeverity)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CRITICALITY:
                setInitialCriticality((ISCriticality)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CRITICALITY:
                setFinalCriticality((ISCriticality)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_SAFE:
                setIsSafe((Boolean)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTICS:
                setDiagnostics((String)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FAILURE_RATE:
                setFailureRate((Double)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CAUSE_OCCURENCE:
                setInitialCauseOccurence((ISOccurence)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CAUSE_OCCURENCE:
                setFinalCauseOccurence((ISOccurence)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__LOCAL_EFFECT_SEVERITY:
                setLocalEffectSeverity((ISSeverity)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SYSTEM_EFFECT_SEVERITY:
                setSystemEffectSeverity((ISSeverity)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__CUSTOMER_EFFECT_SEVERITY:
                setCustomerEffectSeverity((ISSeverity)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTIC_COVERAGE:
                setDiagnostic_coverage((Double)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SSF:
                setSsf((Double)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_DETECTABLE:
                setIsDetectable((Boolean)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DETECTABILITY:
                setDetectability((ISDetectability)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SPREVENTIVE_ACTION_FMEA:
                getSPreventiveActionFMEA().clear();
                getSPreventiveActionFMEA().addAll((Collection<? extends ISPreventiveActionFMEA>)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SCAUSE_FMEA:
                getSCauseFMEA().clear();
                getSCauseFMEA().addAll((Collection<? extends ISCauseFMEA>)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SSYSTEM_EFFECT_FMEA:
                getSSystemEffectFMEA().clear();
                getSSystemEffectFMEA().addAll((Collection<? extends ISSytemEffectFMEA>)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SCUSTOMER_EFFECT_FMEA:
                getSCustomerEffectFMEA().clear();
                getSCustomerEffectFMEA().addAll((Collection<? extends ISCustomerEffectFMEA>)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SLOCAL_EFFECT_FMEA:
                getSLocalEffectFMEA().clear();
                getSLocalEffectFMEA().addAll((Collection<? extends ISLocalEffectFMEA>)newValue);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__BASE_PROPERTY:
                setBase_Property((Property)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SFAILURE_MODE:
                setSFailureMode((ISFailureMode)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__REMARKS:
                setRemarks(REMARKS_EDEFAULT);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SEVERITY:
                setSeverity((ISSeverity)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CRITICALITY:
                setInitialCriticality((ISCriticality)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CRITICALITY:
                setFinalCriticality((ISCriticality)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_SAFE:
                setIsSafe(IS_SAFE_EDEFAULT);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTICS:
                setDiagnostics(DIAGNOSTICS_EDEFAULT);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FAILURE_RATE:
                setFailureRate(FAILURE_RATE_EDEFAULT);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CAUSE_OCCURENCE:
                setInitialCauseOccurence((ISOccurence)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CAUSE_OCCURENCE:
                setFinalCauseOccurence((ISOccurence)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__LOCAL_EFFECT_SEVERITY:
                setLocalEffectSeverity((ISSeverity)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SYSTEM_EFFECT_SEVERITY:
                setSystemEffectSeverity((ISSeverity)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__CUSTOMER_EFFECT_SEVERITY:
                setCustomerEffectSeverity((ISSeverity)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTIC_COVERAGE:
                setDiagnostic_coverage(DIAGNOSTIC_COVERAGE_EDEFAULT);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SSF:
                setSsf(SSF_EDEFAULT);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_DETECTABLE:
                setIsDetectable(IS_DETECTABLE_EDEFAULT);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DETECTABILITY:
                setDetectability((ISDetectability)null);
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SPREVENTIVE_ACTION_FMEA:
                getSPreventiveActionFMEA().clear();
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SCAUSE_FMEA:
                getSCauseFMEA().clear();
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SSYSTEM_EFFECT_FMEA:
                getSSystemEffectFMEA().clear();
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SCUSTOMER_EFFECT_FMEA:
                getSCustomerEffectFMEA().clear();
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SLOCAL_EFFECT_FMEA:
                getSLocalEffectFMEA().clear();
                return;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__BASE_PROPERTY:
                setBase_Property((Property)null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SFAILURE_MODE:
                return sFailureMode != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__REMARKS:
                return REMARKS_EDEFAULT == null ? remarks != null : !REMARKS_EDEFAULT.equals(remarks);
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SEVERITY:
                return severity != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CRITICALITY:
                return initialCriticality != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CRITICALITY:
                return finalCriticality != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_SAFE:
                return isSafe != IS_SAFE_EDEFAULT;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTICS:
                return DIAGNOSTICS_EDEFAULT == null ? diagnostics != null : !DIAGNOSTICS_EDEFAULT.equals(diagnostics);
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FAILURE_RATE:
                return failureRate != FAILURE_RATE_EDEFAULT;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__INITIAL_CAUSE_OCCURENCE:
                return initialCauseOccurence != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__FINAL_CAUSE_OCCURENCE:
                return finalCauseOccurence != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__LOCAL_EFFECT_SEVERITY:
                return localEffectSeverity != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SYSTEM_EFFECT_SEVERITY:
                return systemEffectSeverity != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__CUSTOMER_EFFECT_SEVERITY:
                return customerEffectSeverity != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DIAGNOSTIC_COVERAGE:
                return diagnostic_coverage != DIAGNOSTIC_COVERAGE_EDEFAULT;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SSF:
                return ssf != SSF_EDEFAULT;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__IS_DETECTABLE:
                return isDetectable != IS_DETECTABLE_EDEFAULT;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__DETECTABILITY:
                return detectability != null;
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SPREVENTIVE_ACTION_FMEA:
                return sPreventiveActionFMEA != null && !sPreventiveActionFMEA.isEmpty();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SCAUSE_FMEA:
                return sCauseFMEA != null && !sCauseFMEA.isEmpty();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SSYSTEM_EFFECT_FMEA:
                return sSystemEffectFMEA != null && !sSystemEffectFMEA.isEmpty();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SCUSTOMER_EFFECT_FMEA:
                return sCustomerEffectFMEA != null && !sCustomerEffectFMEA.isEmpty();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__SLOCAL_EFFECT_FMEA:
                return sLocalEffectFMEA != null && !sLocalEffectFMEA.isEmpty();
            case IESFFMEAPackage.SFAILURE_MODE_FMEA__BASE_PROPERTY:
                return base_Property != null;
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (remarks: ");
        result.append(remarks);
        result.append(", isSafe: ");
        result.append(isSafe);
        result.append(", diagnostics: ");
        result.append(diagnostics);
        result.append(", failureRate: ");
        result.append(failureRate);
        result.append(", diagnostic_coverage: ");
        result.append(diagnostic_coverage);
        result.append(", ssf: ");
        result.append(ssf);
        result.append(", isDetectable: ");
        result.append(isDetectable);
        result.append(')');
        return result.toString();
    }

} //SFailureModeFMEA
