/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
/**
 */
package org.polarsys.esf.esffmea.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.polarsys.esf.esfcore.IAbstractSElement;
import org.polarsys.esf.esfcore.IAbstractSSafetyAnalysis;
import org.polarsys.esf.esfcore.IAbstractSSafetyConcept;

import org.polarsys.esf.esffmea.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.polarsys.esf.esffmea.IESFFMEAPackage
 * @generated
 */
public class ESFFMEASwitch<T> extends Switch<T> {
    /**
     * The cached model package
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static IESFFMEAPackage modelPackage;

    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ESFFMEASwitch() {
        if (modelPackage == null) {
            modelPackage = IESFFMEAPackage.eINSTANCE;
        }
    }

    /**
     * Checks whether this is a switch for the given package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param ePackage the package in question.
     * @return whether this is a switch for the given package.
     * @generated
     */
    @Override
    protected boolean isSwitchFor(EPackage ePackage) {
        return ePackage == modelPackage;
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    @Override
    protected T doSwitch(int classifierID, EObject theEObject) {
        switch (classifierID) {
            case IESFFMEAPackage.SFMEA: {
                ISFMEA sfmea = (ISFMEA)theEObject;
                T result = caseSFMEA(sfmea);
                if (result == null) result = caseAbstractSSafetyAnalysis(sfmea);
                if (result == null) result = caseAbstractSElement(sfmea);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.ABSTRACT_SFMEA_ELEMENT: {
                IAbstractSFMEAElement abstractSFMEAElement = (IAbstractSFMEAElement)theEObject;
                T result = caseAbstractSFMEAElement(abstractSFMEAElement);
                if (result == null) result = caseAbstractSSafetyConcept(abstractSFMEAElement);
                if (result == null) result = caseAbstractSElement(abstractSFMEAElement);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.SBLOCK_FMEA: {
                ISBlockFMEA sBlockFMEA = (ISBlockFMEA)theEObject;
                T result = caseSBlockFMEA(sBlockFMEA);
                if (result == null) result = caseAbstractSFMEAElement(sBlockFMEA);
                if (result == null) result = caseAbstractSSafetyConcept(sBlockFMEA);
                if (result == null) result = caseAbstractSElement(sBlockFMEA);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.SFAILURE_MODE_FMEA: {
                ISFailureModeFMEA sFailureModeFMEA = (ISFailureModeFMEA)theEObject;
                T result = caseSFailureModeFMEA(sFailureModeFMEA);
                if (result == null) result = caseAbstractSFMEAElement(sFailureModeFMEA);
                if (result == null) result = caseAbstractSSafetyConcept(sFailureModeFMEA);
                if (result == null) result = caseAbstractSElement(sFailureModeFMEA);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.SPREVENTIVE_ACTION_FMEA: {
                ISPreventiveActionFMEA sPreventiveActionFMEA = (ISPreventiveActionFMEA)theEObject;
                T result = caseSPreventiveActionFMEA(sPreventiveActionFMEA);
                if (result == null) result = caseAbstractSFMEAElement(sPreventiveActionFMEA);
                if (result == null) result = caseAbstractSSafetyConcept(sPreventiveActionFMEA);
                if (result == null) result = caseAbstractSElement(sPreventiveActionFMEA);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.SCAUSE_FMEA: {
                ISCauseFMEA sCauseFMEA = (ISCauseFMEA)theEObject;
                T result = caseSCauseFMEA(sCauseFMEA);
                if (result == null) result = caseAbstractSFMEAElement(sCauseFMEA);
                if (result == null) result = caseAbstractSSafetyConcept(sCauseFMEA);
                if (result == null) result = caseAbstractSElement(sCauseFMEA);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.SSYTEM_EFFECT_FMEA: {
                ISSytemEffectFMEA sSytemEffectFMEA = (ISSytemEffectFMEA)theEObject;
                T result = caseSSytemEffectFMEA(sSytemEffectFMEA);
                if (result == null) result = caseAbstractSEventEffectFMEA(sSytemEffectFMEA);
                if (result == null) result = caseAbstractSFMEAElement(sSytemEffectFMEA);
                if (result == null) result = caseAbstractSSafetyConcept(sSytemEffectFMEA);
                if (result == null) result = caseAbstractSElement(sSytemEffectFMEA);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.ABSTRACT_SEVENT_EFFECT_FMEA: {
                IAbstractSEventEffectFMEA abstractSEventEffectFMEA = (IAbstractSEventEffectFMEA)theEObject;
                T result = caseAbstractSEventEffectFMEA(abstractSEventEffectFMEA);
                if (result == null) result = caseAbstractSFMEAElement(abstractSEventEffectFMEA);
                if (result == null) result = caseAbstractSSafetyConcept(abstractSEventEffectFMEA);
                if (result == null) result = caseAbstractSElement(abstractSEventEffectFMEA);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.SCUSTOMER_EFFECT_FMEA: {
                ISCustomerEffectFMEA sCustomerEffectFMEA = (ISCustomerEffectFMEA)theEObject;
                T result = caseSCustomerEffectFMEA(sCustomerEffectFMEA);
                if (result == null) result = caseAbstractSEventEffectFMEA(sCustomerEffectFMEA);
                if (result == null) result = caseAbstractSFMEAElement(sCustomerEffectFMEA);
                if (result == null) result = caseAbstractSSafetyConcept(sCustomerEffectFMEA);
                if (result == null) result = caseAbstractSElement(sCustomerEffectFMEA);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case IESFFMEAPackage.SLOCAL_EFFECT_FMEA: {
                ISLocalEffectFMEA sLocalEffectFMEA = (ISLocalEffectFMEA)theEObject;
                T result = caseSLocalEffectFMEA(sLocalEffectFMEA);
                if (result == null) result = caseAbstractSEventEffectFMEA(sLocalEffectFMEA);
                if (result == null) result = caseAbstractSFMEAElement(sLocalEffectFMEA);
                if (result == null) result = caseAbstractSSafetyConcept(sLocalEffectFMEA);
                if (result == null) result = caseAbstractSElement(sLocalEffectFMEA);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            default: return defaultCase(theEObject);
        }
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>SFMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>SFMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSFMEA(ISFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Abstract SFMEA Element</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Abstract SFMEA Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAbstractSFMEAElement(IAbstractSFMEAElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>SBlock FMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>SBlock FMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSBlockFMEA(ISBlockFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>SFailure Mode FMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>SFailure Mode FMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSFailureModeFMEA(ISFailureModeFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>SPreventive Action FMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>SPreventive Action FMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSPreventiveActionFMEA(ISPreventiveActionFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>SCause FMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>SCause FMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSCauseFMEA(ISCauseFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>SSytem Effect FMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>SSytem Effect FMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSSytemEffectFMEA(ISSytemEffectFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Abstract SEvent Effect FMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Abstract SEvent Effect FMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAbstractSEventEffectFMEA(IAbstractSEventEffectFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>SCustomer Effect FMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>SCustomer Effect FMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSCustomerEffectFMEA(ISCustomerEffectFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>SLocal Effect FMEA</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>SLocal Effect FMEA</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseSLocalEffectFMEA(ISLocalEffectFMEA object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Abstract SElement</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Abstract SElement</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAbstractSElement(IAbstractSElement object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Abstract SSafety Analysis</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Abstract SSafety Analysis</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAbstractSSafetyAnalysis(IAbstractSSafetyAnalysis object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Abstract SSafety Concept</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Abstract SSafety Concept</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseAbstractSSafetyConcept(IAbstractSSafetyConcept object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch, but this is the last case anyway.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    @Override
    public T defaultCase(EObject object) {
        return null;
    }

} //ESFFMEASwitch
