/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.fmea.impl;

import org.polarsys.esf.esffmea.IESFFMEAFactory;
/**
 * This factory overrides the generated factory {@link ESFArchitectureConceptsFactory}
 * and returns the new generated interfaces.
 *
 * @author $Author: ogurcan $
 * @version $Revision: 186 $
 */
import org.polarsys.esf.esffmea.impl.ESFFMEAFactory;
import org.polarsys.esf.fmea.IMESFFMEAFactory;
import org.polarsys.esf.fmea.IMSFMEA;


public class MESFFMEAFactory
    extends ESFFMEAFactory
    implements IMESFFMEAFactory {
    
    /**
     * Default constructor.
     */
    public MESFFMEAFactory() {
        super();
    }
    
    /**
     * @return The initialised factory
     */
    public static IMESFFMEAFactory init() {
        IESFFMEAFactory vFactory = ESFFMEAFactory.init();

        // Check if the factory returned by the standard implementation can suit,
        // otherwise create a new instance
        if (!(vFactory instanceof IMESFFMEAFactory)) {
            vFactory = new MESFFMEAFactory();
        }

        return (IMESFFMEAFactory) vFactory;
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    public IMSFMEA createSFMEA() {
        IMSFMEA vFMEA = new MSFMEA();
        return vFMEA;
    }

}
